#!/usr/bin/wish

# By Werner Riebesel: Since V9.0 this is the new front end for jongl

#A  History 

# 571 tests
# 671 start with tixnotebook
# 771 most things are visible, many not working; start writing jongl.prefs
# 871 checkbuttons work; develop added
# 971 graphics layout improved
# 1071 small things
# 1171 even more buttons; OpenFile removes path to jongl
# 1871 connected entry to -textvariable; save shading correctly; read most of jongl.prefs
# 2371 read optional 8.3 of povraydir; 1bit-logo; colors, whodidit; COMMERCIAL
# 2471 gif-logo; colored pattern layout with radiobuttons; bind -> which
# 2571 returns the right pattern; trimpath
# 2671 write and read dev options with comment signs
# 2771 start invoking this with C program (does not work with Tk, only with Tcl)
# 181 start Tk with C; redesign without tix.notebook; use wish instead of tixwish;
#        bound focus to entry, bound update to any-keypress; started with localText() 
# 281  save pattern & siteswap to jongl.prefs; localText() complete
# EJC 2001 Rotterdam
# 1381 {destroy .} instead of exit -> works with C (once)
# 1581 removed tempdir from options; works multiple times
# 1681 Internal values added to jongl.prefs
# 1781 save current register for next start
# 2281 center window in screen, failed to use minwidth and -height;
#         J2 patterns work
# 2381 J2 remembers last pattern
# 2481 lots of options for J2 --> separate window
# 2681 more options for J2
# 2781 J2 works with sync, partly with passing
# 2981 J2 works with passing; freestyle
# 191 jMsg works nearly completely
# ..  tested fork() and destroyed file system of my Linux box
# 2291 restored system
# 2891 attached filereq.tcl
# 21101 added 2 reset buttons in graphic
# 25101 time stretch works with J2 and siteswap and patterns_from_file
# 26101 j2_options_window restores old state
# 15111 factor for speed of rotation in 3D window added
# 412 support for whitespace in siteswap patterns, file name etc.
# 512 separate pages for patterns and siteswap
# 322 switch for random colored objects
# 1022 started with objects window
# 1622 added object_type to jongl.prefs file
# 532 added espanol
# 1632 removed old objects; added selection for floor
# 1932 added ground selection depending on texturing
# 2032 added IncludeNewShirts
# 2132 added HelpINS
# ----------------- V9.0
# 3032 added sync for freestyle (idea of Derek Bosch)
# 252 freestyle: don't allow every combination of input; Multiplex, Radius
# 1252 cosmetic improvements
# 1852- set siteswap throws depending on hands or siteswap throws
#
# 1634 j2-output tolower for s22j
# 2534 small things
# 2634 added some restrictions to TraceFreestyle
# 1454 added catala as 5th language
# 17+2154 support for blue buttons on MacOSX
# 664  selector for radius at siteswap register tab
# 764  dito at J2 tab
# 18-201004 added transitions display for siteswap pattern
# 201004 added granite floor
# 21-231004 multi handed siteswaps
# 20114 parameters for hands available for both "siteswap" and "j2" 
# 27114 added "solo mode" and "standard mode"
# 28114 added sync mode checks to validSS
# 16124 V12.1 runs under Linux SuSE8.1 
#              added buttons for throwing transitions in siteswap patterns
# 17124 throwing transitions works with siteswaps
# 18124 and with j2 solo async
# 24124 improved debugging features for windoze
# 26124 PgUp/Dn works with currentregister == pattern
# 30-31124 fixed some bugs which Ludwig found
# 115 program warns if j2 file list does not fit to the current parameters
# 415 made help text for s22j translateable
# 615 j2_sync and j2_passing are mutually exclusive
# 715 added 3person to j2
# 815 max. patterns for j2
# 725 added KarobodenTest
# 1735 Setup
# 1455 Setup debugged, V13.0 for Win released
#
# 865 write trans_in & _out to jongl.prefs (for start-notation.html) 
# 30105 JRC option disabled - added "set scatter=0"
# 216 deactivate button "sync" in some cases (multihanded,..)
# 316 added async2sync (correct transitions for sync patterns)
# 516 started more options for transitions (using "any/fart"-binary from J.Weissl)
# 616 0x handling in sync transitions, disabled sync button if useless 
# 326 updateSyncButton works (hopefully)
# 426 selectPano works - DIRECT_CALL is set automatically
# 2046 start-notation works for siteswap input
# 2246 setup-check works with old version numbers, too
# 1766 transitions for 2 and 3 jugglers in j2 
#           (TODO: search for better ground state pattern)
#  -- very long break ------
# 1218 added bostonmess.exe from Ludwig
# 1318 ditto with J2
# 1718 slider in GUI for bostonmess

#E
#A  TODO:

# "fart" kennzeichnet zu ndernde Stellen
# Passing (j2 und ss): bergnge berechnen und werfen
# j2_options: "selfs vermeiden": muss 10 heien, 
#        Konvertierung von A,a einbauen oder Text ergnzen
#  "Radius" ausblenden, wenn unntig
#  j2_active_index wird zwischenzeitlcih gelscht: wenn in der j2-Liste
#           nichts ausgewhlt wurde (alte Auswahl blieb) und dann auf JONGL-button 
#           geklickt
# throw trans fr j2_passING: Hauptproblem: wie sieht das Grundmuster aus?
#    (siehe makePatternWithTransitions(), vielleicht geschickt 1 Muster von den mit j2
#     generierten auswhlen, dann stimmt der Status sicher
# validSS: check passing/feed (spter noch Multiplex)
# so2n anbinden + Erklrung dazu; evtl. reicht ein breiter button mit Beschriftung 
#            "<j1h1|j2h1> <j1h2|j2h2>" oder so (sollte mehrsprachig sein: d/e/f/usw. !)
#
# --- next release ---
#
# Button fr: Siteswap in der Zeit umdrehen?
# putsDebug so ndern, dass nur bei windows das Fenster kommt, sonst "puts"
# Buttons fr "jongl random" und "jongl order" einbauen und benchmarkX
# Lasche Siteswap/J2: Muster abh. von Hand bzw. Wurf fertig machen 
#       + vertikale Scrollbar fr zu lange siteswap-Muster, wo jeder einzelne Wurf parametrisiert ist
# Testen: extrem lange siteswap-Muster: irgendwo Buffer-berlauf? z.B. Milde10
# freestyle: bounce -> report; multiplex einbauen
# timestretch geht mit freestyle nicht? (Windows: OK - Linux: ?? - Mac: ??)
# siteswap-Romm-Programm einbauen

# {{{
# for folding recognition
# }}}

#E
#A  Init

# When called from Jongl, DIRECT_CALL is set to 0
#
# For debugging, start this from jongl/tcl directory. 
# Then DIRECT_CALL is set automatically to 1. 

set DIRECT_CALL 0
set curpath [ file split [ pwd ] ]
foreach p $curpath { 
	if { [ string compare "tcl" $p ] == 0 } {
		set DIRECT_CALL 1
		break
	}
}

# Testing on Windows: open DOS-box in jongl/tcl dir. Type "wish84t prefs.tcl" 

# set COMMERCIAL 0 ;# debugging version
# set COMMERCIAL -1 ;# -> create new jongl.prefs
set COMMERCIAL 0 ;# distribution version

# DEBUG & 1 -> debug prefs.tcl
# DEBUG & 2 -> debug filereq.tcl
set DEBUG 0

set DO_NOT_READ_JONGL_PREFS 0

# to test if setup ran already:
set SETUP_FILE "tmp/setup.complete"

if { $DIRECT_CALL == 1 } {
	# run inside of jongl/tcl dir -> no tcl/ in source call
	source "common_functions.tcl"
	# Let this run without a C program:
	proc LT { ignore } { return [ format  "LT %d" $ignore] }
	proc KillChild { } { }
	proc SetLanguage { ignore } { }
	# write parameter file:
	set id [open $TCL_PASSING_FILE w]
	puts $id "Jongl\n\n\n0\n\n"
	close $id
	# change to jongl/ dir.
	cd ".."
} else {
	source "tcl/common_functions.tcl"
}

source "tcl/pano.tcl"
source "tcl/update.tcl"

set auto_change 0
set avoid_throws something_to_make_this_global
set currentregister something_to_make_this_global
set ground_pattern -1
set j2_max_patterns 1000
set j2_passing something_to_make_this_global
# JonglRemoteControl window does not work:
set jrc 0
set num_obj -1
set trans_in something_to_make_this_global
set trans_out something_to_make_this_global

# if the following will be extended, 
# adjust appropriate enum @ prefs.h
# and switch 'c' in parseOptions() @ inout.c 
set framelist { pat ss j2 fre set exp }

set fart_temp_file "tmp/fart"

set frefile "freestyle.out"

# this must be the same as in dreiDsteuerung.c: J2FILE 
set j2file "j2.out"

set prefsfile "jongl.prefsV9"

set panodir "pano"

# globals for filereq.tcl:
# BE SURE TO INSERT THEM IN OpenFile{} !!!
set allpatternsshown 0
set firstinit 2
set MAXOBJ 100
set patdir "m/"
set patterndir "m/"
set patfilter "*"
set patternfilter "*"
set wfq .filereq

# globals for j2_options_window.tcl:
set ww .j2-options

# globals for trans_options.tcl:
global avoid_throws
set init_fart 0
set _static_wm_setup 0
global trans_much_options
global trans_text2
global trans_len_in   trans_len_out   trans_height_in   trans_height_out
set trans_changed_by_fart 0
set wt .trans_options

set init_fart 0 ; # 0: not init. yet - 1: init now - 2: has been initialized
## fart: source "tcl/trans_options.tcl"

# globals for objects.tcl:
set object_type -1
set objects_window 0

#A #### arrays:

set shade(0) [LT 2704] ;# "no" 
set shade(1) [LT 2705] ;# "shaded" 
set shade(2) [LT 2706] ;# "shadows"
set shade(3) [LT 2707] ;# "gouraud shading with shadows" 
set shade(4) [LT 2708] ;# "lightcone" 
set shade(5) [LT 2709] ;# "gouraud shading"

set state(0) [LT 2757]  ;# ground state patterns
set state(1) [LT 2758]  ;# all patterns
set state(2) [LT 2759]  ;# excited state patterns

# DEPRECATED:
# add new floor:
# - add lines to both following blocks
# - create new file in v/basic/Karoboden*
# - add text in l/*
# - add [LT new] in TraceTextures
# 
# set ground_name(0) [LT 2792] ;# meadow
# set ground_name(1) [LT 2874] ;# gym floor
# set ground_name(2) [LT 2793] ;# gym
# set ground_name(3) [LT 2794] ;# beach
# set ground_name(4) [LT 2795] ;# tiles
# set ground_name(5) [LT 2796] ;# chessboard
# set ground_name(6) [LT 2830] ;# granite
# set ground_name(7) "-- Test --"
# 
# set ground_file(0) "KarobodenMeadow"
# set ground_file(1) "KarobodenGymFloor"
# set ground_file(2) "KarobodenGym"
# set ground_file(3) "KarobodenBeach"
# set ground_file(4) "KarobodenTiles"
# set ground_file(5) "KarobodenChessboard"
# set ground_file(6) "KarobodenGranite"
# set ground_file(7) "KarobodenTest"

#E

# 1 hand has 13 characters of declaration
set LEN1HAND 13

#E
#---------------------------------------------------------------
proc async2sync { ss } {
#A convert async pattern to sync pattern. in & output is STRING
	
	set len [ string length $ss ]
	if { [ Odd  $len ] } { 
		# error: does not work with odd length
		return -1 
	} 
	
	# throws at even positions: -=1
	# throws at odd positions: +=1
	# counting starts with 0
	# odd throws get an "x" appended

	# remove chars in standard mode
	set sst [ TrimSS $ss 0 ]
	set ssl [ makeListFromString $sst ] ; # strip spaces

	for { set t 0 } { $t < $len } { incr t } {
		set throw [ lrange $ssl $t $t ]
		if { [ Odd $throw ] } {
			if { [ Odd $t ] } {
				# odd throw at odd position -> +=1
				set ssl [ lreplace $ssl $t $t [ format "%sx" [dec2hex [expr [hex2dec $throw] +1 ]]]]
			} else {
				# odd throw at even pos -> -=1
				set ssl [ lreplace $ssl $t $t [ format "%sx" [dec2hex [expr [hex2dec $throw] -1 ]]]]
			}
		} else {
			# replace to get 'a' instead of '10'
			set ssl [ lreplace $ssl $t $t [ format "%s" [dec2hex $throw]]]
		}
		# even throws are not modified
	}
	
#A special handling for 0x
	if { [ lsearch $ssl "0x" ] != -1 } {
		# found "0x" in modified transition -> 
		# site swap 1st and 2nd element of list
		set t1 [ string index $ss 0 ]
		set t2 [ string index $ss 1 ]
		set len [ string length $ss ]
		# make list with site swapped throws
		lappend sl [ expr $t2 + 1 ]
		lappend sl [ expr $t1 - 1 ]
		for { set i 2 } { $i < $len } { incr i } {
			lappend sl [ string index $ss $i ]
		}
		# convert once more:
		return [ async2sync [ join $sl "" ] ]
	}
	#E
	
	return [ join $ssl "" ]
}
#E
#---------------------------------------------------------------
proc Check4Mac { } {
#A   
	global tcl_platform

	if { [ string equal $tcl_platform(os) "Darwin" ] } {
		return 1
	} else {
		# possible values here are:
		# "Windows NT" (even if running on XP)
		# ... enter Linux output here ...
		return 0
	}
}
#E
#---------------------------------------------------------------
proc Convert_ss_hands { } {
#A   build parameter for s22j
    global ss_hands LEN1HAND

    set num_jug [ expr [ string length $ss_hands ] / (2*$LEN1HAND) ]

    for { set j 1 } { $j <= $num_jug } { incr j } {
        global ss_left_$j ss_bounce_left_$j ss_z_left_$j
        global ss_right_$j ss_bounce_right_$j ss_z_right_$j
        
        # left hand:
        set this_hand [ string range $ss_hands [ expr ($j-1)*2*$LEN1HAND ] [ expr (2*$j-1)*$LEN1HAND-1 ] ]

        set ss_left_$j [SS_convert [ string range $this_hand 0 0 ] EXPAND ]
        set ss_bounce_left_$j [SS_convert_spbo [ string range $this_hand 1 8] EXPAND ]
        set ss_z_left_$j [SS_convert_Z [ string range $this_hand 9 12] EXPAND ]

        # right hand:
        set this_hand [ string range $ss_hands [ expr (2*$j-1)*$LEN1HAND ] [ expr $j*2*$LEN1HAND-1 ] ]

        set ss_right_$j [SS_convert [ string range $this_hand 0 0 ] EXPAND ]
        set ss_bounce_right_$j [SS_convert_spbo [ string range $this_hand 1 8] EXPAND ]
        set ss_z_right_$j [SS_convert_Z [ string range $this_hand 9 12] EXPAND ]
        
    }

}
#E
#---------------------------------------------------------------
proc Convert_ss_siteswap { } {
#A   build parameter for s22j
    global ss_siteswap LEN1HAND

    set ss_len [ expr [ string length $ss_siteswap ] / $LEN1HAND ]

    for { set t 1 } { $t <= $ss_len } { incr t } {
        global ss_$t ss_bounce_$t ss_z_$t
        
        set this_hand [ string range $ss_siteswap [ expr ($t-1)*$LEN1HAND ] [ expr $t*$LEN1HAND-1 ] ]

        set ss_$t [SS_convert [ string range $this_hand 0 0 ] EXPAND ]
        set ss_bounce_$t [SS_convert_spbo [ string range $this_hand 1 8] EXPAND ]
        set ss_z_$t [SS_convert_Z [ string range $this_hand 9 12] EXPAND ]
    }
}
#E
#---------------------------------------------------------------
proc dec2hex { dec } {
#A input "10" -> output "a"
	if { $dec <10 } {
		return $dec
	} else {
		return [format "%c" [expr $dec+87]]
	}
}
#E
#---------------------------------------------------------------
proc fac_minus_1 { n } { 
	#A computes faculty of n  ( = n!) and returns 1 less

	set f 1
	while { $n > 1 } {
		set f [ expr $f * $n ]
		incr n -1
	}
	return [ incr f -1 ]
}
#E
#---------------------------------------------------------------
proc Freestyle_start { }  {
#A

    global frefile
    global fre_bounce
    global fre_empty_hand
    global fre_jug
    global fre_mplex
    global fre_maxMplex
    global fre_numobj
    global fre_period
    global fre_radius
    global jugglingpattern
    global object_type
    global sync
    global COMMERCIAL

    set fre_cmd "./freestyle $fre_jug $fre_numobj $fre_period -n "
    if { $COMMERCIAL == 0 } {
        lappend fre_cmd "-b$fre_bounce" 
    }
    if { $fre_jug > 1 } {
        lappend fre_cmd "-r$fre_radius" 
    }
    if { $fre_mplex > 0 } {
        lappend fre_cmd "-m$fre_mplex" 
        lappend fre_cmd "-M$fre_maxMplex" 
    }
    lappend fre_cmd "-e$fre_empty_hand" 
    if { $object_type >=0 } {
        lappend fre_cmd "-o$object_type" 
    }
    if { $sync >0 } {
        lappend fre_cmd "-s"
    }

#  putsDebug $fre_cmd

    # invoke freestyle and write results to file
    eval exec $fre_cmd

    set jugglingpattern {}

}

#E
#---------------------------------------------------------------
proc HelpINS { } {
#A   help for IncludeNewShirts

    wm withdraw .
    toplevel .ins_help
    wm title .ins_help [LT 2797]

    set minheight 30
    set minwidth 71

    set help [ open "list_of_shirts.EJC" r ]
    if { $help == 0 } return

    set f [frame .ins_help.f]
      text $f.t -yscrollcommand "$f.s set" -height $minheight -width $minwidth
      pack $f.t  -side left -expand 1 -fill both
      scrollbar $f.s -command "$f.t yview" 
      pack $f.s -side right -expand 1 -fill y
    pack $f -expand true -fill both

    button .ins_help.ok -text OK -command { destroy .ins_help }
    pack .ins_help.ok -side bottom -padx 5 -pady 5 

    while { 1 } {
        gets $help line
        if { [ string first "EOF" $line ] > 0 } break
        $f.t insert end "$line\n"
    }

    close $help

}
#E
#---------------------------------------------------------------
proc hex2dec { hex_str } {
#A converts hex character, output in decimal ('a'='A'=10)
  
  scan $hex_str %c dec_val
	if { $dec_val <58 } {
		# re-read number
		scan $hex_str %d dec_val
	} else {
		# convert chars to numbers: a/A -> 10
		incr dec_val -55
		# if it was 'a' instead of 'A':
		if { $dec_val >26+9 } { incr dec_val -32 }
	}
	return $dec_val
}
#E
#---------------------------------------------------------------
proc highestThrow { ss } {
#A compute highest throw in pattern
	
	# trim siteswap pattern
	set sst [ TrimSS $ss 0 ]

	set max 1
	
	for { set i 0 } { $i < [ string length $sst ] } { incr i } {
		set t [ string index $sst $i ]
		if { $t > $max } { set max $t }
	}
	return $max
}
#E
#----------------------------------------
proc IncludeNewShirts { } {
#A

#A init
    wm withdraw .
    toplevel .ins
    wm title .ins [LT 2797]

    set minheight 30
    set minwidth 74
    set shirtcount 0
    set LOS "list_of_shirts"

    set f [frame .ins.f]
      text $f.t -yscrollcommand "$f.s set" -height $minheight -width $minwidth
      pack $f.t  -side left -expand 1 -fill both
      scrollbar $f.s -command "$f.t yview" 
      pack $f.s -side right -expand 1 -fill y
    pack $f -expand true -fill both
    
    set f1 [ frame .ins.but ]
      button $f1.ok -text OK -command { destroy .ins }
      pack $f1.ok -side left -padx 5 -pady 5 

      button $f1.help -text "how to" -command HelpINS
      pack $f1.help -side right -padx 5 -pady 5
    pack $f1

    file rename -force $LOS $LOS-backup

    set los_list [glob "list_of_shirts.*"]

    set fpout [open $LOS w]
    puts $fpout "!\n! list_of_shirts\n!\n! Automatically generated file. Do not change!\n"
#E

    foreach los $los_list {
        if { [ string index $los end] == "~" }  continue
        $f.t insert end "$los:\n"
        set ok 0
        set frontbitmap 0
        set backbitmap 0
        set fpin [open $los r]
        while { ! [ eof $fpin] } {
            gets $fpin line
            set line [string trim $line]
            if { [string index $line 0] != "!" && [string length $line] > 1} {
                if { [string first ":" $line] > 0} {
#A                shirt name
                    $f.t insert end "  $line\n"
                    # write previous shirt to fpout:
                    if { $ok > 0} {
                        Write1Shirt $fpout $shirtname $frontbitmap $backbitmap
                        incr shirtcount
                        set frontbitmap 0
                        set backbitmap 0
                    }
                    set shirtname $line
                    set ok 0
#E
                } else {
#A                bitmap
                    $f.t insert end "    $line  -->  "
                    set bitmap [string range $line [string first "=" $line] end]
                    set bitmap [string trim $bitmap " ="]
                    if { [file exists $bitmap] } {
                        $f.t insert end "OK\n"
                        if { [ string first "frontBitmap" $line ] >= 0 } {
                            set frontbitmap $line
                            incr ok 
                        } elseif { [ string first "backBitmap" $line ] >= 0 } {
                            set backbitmap $line
                            incr ok 
                        } else {
                            putsDebug "Error 2002-0320 in tcl/prefs.tcl:IncludeNewShirts"
                        }
                    } else {
                        $f.t insert end "[LT 17]\n"
                        # [LT 40 $bitmap] does not work
                        set ok -17
                        set frontbitmap 0
                        set backbitmap 0
                    }
#E
                }
            }
        }
#A    write after EOF:
        if { $ok > 0} {
            Write1Shirt $fpout $shirtname $frontbitmap $backbitmap
            incr shirtcount
        }
#E
        close $fpin
    }
    close $fpout

    $f.t insert end "\nlist_of_shirts -> list_of_shirts-backup\n"
    $f.t insert end [ format "\n%d T-Shirts in list_of_shirts\n\n" $shirtcount ]
    $f.t see end
}

#E
#---------------------------------------------------------------
proc isInt { val } {
#A   returns 1 if $val == int($val)

	if { [ expr int($val)] == $val } { 
		return 1 
	} else { 
		return 0 
	}
}
#E
#----------------------------------------
proc J2_fill_listbox { }  {
#A   and count number of patterns

    global j2file  j2_passing  j2_max_patterns
    global w

    set j2f $w.j2.lb

    if { ! [file exists $j2file] } return
    
    # read file and display buttons:
    set id [open $j2file r]
    
    # delete old entries in listbox:
    $j2f.lb delete 0 end 
    set count 0
    while { [gets $id line] >= 0} {
			if { [ string first "top" $line ] > -1 } {
				# max. no. of pattern reached
				close $id
				$w.j2.lcp configure -text [ format "[LT 2871]" $j2_max_patterns ]   
				return
			}
			$j2f.lb insert end [ string trimright $line] 
      incr count
    }
    
    close $id

    $w.j2.lcp configure -text "$count [LT 2710]"
}

#E
#----------------------------------------
proc J2_find_line { in_pattern }  {
#A   find line in j2file: input: "771" -> output "66 771 3"

    global j2file

    if { ! [file exists $j2file] } return
    
    # read file
    set id [open $j2file r]
    
		# was necessary, because J2 outputs uppercase
		# and jongl/s22j need lowercase
#		set in_pat [ string tolower $in_pattern ]
    while { [gets $id line] >= 0} {
#			set l_line [ string tolower $line]
			if { [ string first  $in_pattern $line] > -1} {
					close $id
					return $line
			}
    }
    
    close $id
		return $in_pattern  ; # should never be here, but return save value
}

#E
#----------------------------------------
proc J2_options_window { show } {
#A

    # globals for j2_options.tcl:
    global state j2_passing p w xpos ypos
    # globals for this:
    global j2_options_window ww  
		global sync j2_decomp j2_11 j2_i j2_x j2_xp j2_state

    switch $show {
        "on" {
            set j2_options_window 1
            $w.j2.b.j2_options configure -text "[LT 2800]"
            source "tcl/j2_options.tcl" 
        }
        "off" {
            set j2_options_window 0
            $w.j2.b.j2_options configure -text "[LT 2801]"
            if { [ winfo exists $ww ] } {
                destroy $ww 
            }
        }
        "toggle" {
            if { ! $j2_options_window } { 
                J2_options_window on
            } else {
                J2_options_window off
            }
        }
    }

}

#E
#---------------------------------------------------------------
proc J2_start { }  {
#A   starts j2 and fills listbox with patterns  
  	
#A  globals

		global avoid_throws ; # multi handed siteswap
    global j2file
    global j2_11
    global j2_active_index
    global j2_decomp
		global j2_gen_pat_but
    global j2_i
    global j2_last_max
    global j2_last_numobj
    global j2_last_period
    global j2_max
		global j2_max_patterns
    global j2_numobj
    global j2_passing
    global j2_period
    global j2_state
    global sync
    global j2_x
    global j2_xp
    global jugglingpattern
	  global num_ss_hands ; # mhss, contains e.g. [LT 2838]
		global show_j2_call
    global state
    global sync
    global w
#E
    
  set mhss_hands [ MHSS_num_hands ]

#A  compose calling sequence

    if { $sync } {
			# do not allow odd length
			set j2__period [ expr $j2_period * 2 ]
		} else {
			set j2__period $j2_period
		}

		set j2_cmd "j2/j2 $j2_numobj $j2_max $j2__period -max $j2_max_patterns -s22j"
    
    set j2_last_max $j2_max
    set j2_last_numobj $j2_numobj
    set j2_last_period $j2_period

    if { $j2_11 } { lappend j2_cmd "-lame" }

    if { $j2_decomp } { 
        lappend j2_cmd "-f" 
    } else {
        lappend j2_cmd "-simple"
    } 

    if { [string length $j2_i] } { 
        regsub -all {[,]} $j2_i " " output    
        lappend j2_cmd "-i" 
        foreach i $output {
            lappend j2_cmd $i
        }
    }

    switch $j2_passing {
			2 { lappend j2_cmd "-p" }
			3 { # 2 lines, because otherwise it would be {-c 3person}
						lappend j2_cmd "-c"
						lappend j2_cmd "j2/3person" }
		}

    # switch did not work
    if { [string compare $j2_state $state(0)] == 0 } { 
        lappend j2_cmd "-g" 
    }
    if { [string compare $j2_state $state(2)] == 0 } { 
        lappend j2_cmd "-ng" 
    }

    if { $sync } { 
        lappend j2_cmd "-s" 
#        set sync 1
#    } else {
#        set sync 0
    }

    if { [string length $j2_x] || ( $mhss_hands > 2 ) } { 
        regsub -all {[,]} $j2_x " " output    
        lappend j2_cmd "-x" 
        foreach i $output {
          lappend j2_cmd $i
        }
				if { $mhss_hands > 2 } {
					# ignore throws which do not work with current multi handed siteswap
					foreach i $avoid_throws {
						# otherwise the whole list is appended as 1 element: { 1 2 }
						lappend j2_cmd $i
					}
				}
    }

    if { $j2_passing >=2 } {
        if { [string length $j2_xp] } { 
            regsub -all {[,]} $j2_xp " " output    
            lappend j2_cmd "-xp" 
            foreach i $output {
                lappend j2_cmd $i
            }
        }
    }

		lappend j2_cmd "-write"
		lappend j2_cmd $j2file
		
#E
		
		if { $show_j2_call } {
	 		tk_messageBox -message $j2_cmd -type ok -title "j2 call"
		}

    # invoke J2 and write results to file
    eval exec $j2_cmd

    J2_fill_listbox

    set jugglingpattern {}

		# change "generate pattern" button to up-to-date:
		set j2_gen_pat_but 1
		TraceJ2 bla bla bla
		
}

#E
#---------------------------------------------------------------
proc Jongl { } {
#A   START JONGL WITH SELECTED PARAMETERS

    global currentregister
    global frefile
    global j2_active_index j2_numobj  j2_passing
    global jugglingpattern
    global pattern   num_obj   siteswap
    global trans_in  trans_out  throw_trans  trans_ground   trans_siteswap 
    global trans_changed_by_fart
		global w

    # make ss_hands and ss_siteswap up-to-date:
    TraceSS_options bla bla bla

    switch  $currentregister {
        pat {
            WriteJonglPrefs $pattern 0
            destroy .
        }
        ss {
#A
            if { $throw_trans } {
                set trans_pattern [ makePatternWithTransitions $num_obj $trans_in \
                                        $siteswap $trans_out ]
                WriteJonglPrefs $trans_pattern 1
            } else {
                WriteJonglPrefs $siteswap 1
            }
            destroy .
#E
        }
        j2 {
#A
            set j2f $w.j2.lb
            set j2_active_index [$j2f.lb index active]
            set select [selection own]
            #            puts [format "select=%s" $select]
            if { $select == "" } {
                # "please select something first":
                tk_messageBox  -icon info -title Info -message [LT 2755]
                return
            }
            set select [selection get]

#						set num_obj $j2_numobj

						# compute trans_in, trans_out and j2_pattern:
						set j2_pattern [ SeparateJ2throws $select ]
						
            if { $throw_trans } {
                set trans_pattern [ makePatternWithTransitions $j2_numobj $trans_in \
                                        $j2_pattern $trans_out ]
                WriteJonglPrefs $trans_pattern 1
            } else {
                WriteJonglPrefs $j2_pattern 1
            }
            destroy .
#E
        }
        fre {
#A
            Freestyle_start
            WriteJonglPrefs $frefile 0
            destroy .
#E
        }
        default {
            WriteJonglPrefs $jugglingpattern 0
            destroy .
        }
    }
    # default has to be the last item.
}

#E
#----------------------------------------
proc makeGroundPattern { num_obj } {
#A  compute ground state pattern using number of objects

  global sync  j2_passing  ground_pattern  currentregister
	global j2_numobj j2_max j2_period
	
	if { $sync } {
		if { [ Odd $num_obj ] } {
			# odd number -> half shower
			# this direction (left) fits to ground state in j2
			set a [ dec2hex [ expr $num_obj-1] ]
			set b [ dec2hex [ expr $num_obj+1] ]
			# above: the only way to get "4" instead of " 4"
			set ground_pattern [ format "%sx%sx" $a  $b ]
		} else {
			# even number -> fountain
			set ground_pattern [ format "%s%s"  [dec2hex $num_obj]  [dec2hex $num_obj ]]
		}
   } elseif { $currentregister == "j2" && $j2_passing >= 2 } {
		 # TODO: 
		 # think about a sensible ground state pattern with
		 # given number of objects
		 #A         let j2 compute ground state pattern:
		 #TODO: this is NOT the best ground state pattern:
		 set j2gs_file "tmp/j2_ground_state"
		 if { $j2_passing == 2 } {
			 set j2_cmd "j2/j2 $j2_numobj $j2_max 2 -g -s22j -p -max 1 -write "
		 } else {
			 set j2_cmd "j2/j2 $j2_numobj $j2_max 2 -g -s22j -max 1 -c j2/3person -write "
		 }
		 lappend j2_cmd $j2gs_file
		 
		 eval exec $j2_cmd
		 
		 set id [ open $j2gs_file r ]
		 set ground_pattern [ TrimSS [ gets $id ] ABCxp ]
		 close $id
		 #E
	 } else {
		 # ground state pattern == number of objects
		 set ground_pattern [ dec2hex $num_obj ]
	 }
	 return $ground_pattern
}
#E
#----------------------------------------
proc makeListFromString { str } {
#A  Input "b01" -> output "11 0 1"

  set p [ string length $str ]
	
	if { $p == 0 } { return {} }
	# make a list from input string
	for { set i 0 } { $i < $p } { incr i } {
		set t [string index $str $i]
		if { $t != " " } { ; # remove spaces
			if { $t >= "A" } {
				set t  [ hex2dec $t ]
			}
			lappend ssl $t
		}
	}
	return $ssl
}
#E
#----------------------------------------
proc makePatternWithTransitions { num_obj trans_in pattern trans_out } {
#A  set up pattern with transitions:

    # see dreiDextern.c: function with same name and
    # similar functionality 

    global trans_ground trans_siteswap
    global sync  j2_passing  j2_numobj  j2_max  j2_period
    global currentregister w  show_trans_window

    if { [ info exist w ] } {
			# don't do this if started without creating GUI
			if { $show_trans_window == 0 } {
        	# no transitions if button is disabled
					return $pattern
			}
		}

		if { $sync } {
			# half number of throws, because sync throws are 
			# always 2 at a time
			set ground_count [ expr int (($trans_ground / 2.0) + 0.51 ) ]
		} else {
			set ground_count $trans_ground
		}

		if { [ Odd $trans_siteswap ] } { 
			set trans_siteswap_offset 1
		} else {
			set trans_siteswap_offset 0
		}		
		
		set ground_pattern [ makeGroundPattern  $num_obj ]
		    
    # build throwing sequence:
    for { set i 0 } { $i < $ground_count } { incr i } {
        append trans_pattern $ground_pattern
    }
    append trans_pattern " "
    append trans_pattern $trans_in
    append trans_pattern " "
    for { set i 0 } { $i < [ expr $trans_siteswap + $trans_siteswap_offset ] } { incr i } {
        append trans_pattern $pattern
        append trans_pattern " "
    }
    append trans_pattern $trans_out

    return $trans_pattern
}
#E
#----------------------------------------
proc MHSS_num_hands { } {
#A  returns number of currently used hands in multi handed siteswap (incl. std. p=pass)

	global num_ss_hands

	if { $num_ss_hands == "[LT 2832]" } { 
		# 4-handed
		return 4 
	} elseif { $num_ss_hands == "[LT 2833]" } {
		# 6-handed
		return 6 
	} elseif { $num_ss_hands == "[LT 2834]" } {
		# 8-handed
		return 8 
	} elseif { $num_ss_hands == "[LT 2835]" } {
		# 10-handed
		return 10 
	} elseif { $num_ss_hands == "[LT 2838]" } { 
		# Standard (p=pass)
		return 0 
	}
	# solo-mode
	return 2
}
#E
#----------------------------------------
proc nextZero { stat } {
#A  searches in $stat for the rightmost zero 
#   and returns number of bit shifts
	
	set nz 0
	set st $stat
	while { $st > 0 } {
		if { ! [ Odd $st ] } { return $nz }
		incr nz
		set st [ expr int ($st/2) ]
	}
	# must never be HERE
	return -1
}
#E
#----------------------------------------
proc Odd { val } {
#A  returns 1 if $val is odd, else 0
  #	if { [ expr int($val) & 1 ] } 
	if { [ expr [ hex2dec $val ] & 1 ] } {
		return 1
	} else {
		return 0
	}
}
#E
#----------------------------------------
proc OpenFile { }  { 
#A  select pattern file using tcl/filereq.tcl  

    global TCL_PASSING_FILE

# Every variable which "tcl/filereq.tcl" wants to use
# must be mentioned with global here!

    global fq_bounce
    global fq_filter
    global fq_jug
    global fq_max_obj
    global fq_min_obj
    global fq_mplex
    global fq_sort
    global jongldir
    global jugglingpattern
    global patdir
    global patfilter
    global pattern
    global patterndir
    global patternfilter
    global patternwithpath
    global wfq

    set is_pattern_selector true
    set patdir [string range $patternwithpath 0 [string last / $patternwithpath]]
		set padipa_co $patternwithpath
		
    source "tcl/filereq.tcl"
    tkwait window $wfq
    cd $jongldir
		
    if { $patternwithpath != "false" } {
        set pattern $patternwithpath
        set patterndir [file dirname $pattern]
        TrimPath
				Jongl
    } else {
				set patternwithpath $padipa_co
		}
} 

#E
#---------------------------------------------------------------
proc Quit { } { 
#A  quits jongl

	# This (tcl/prefs.tcl) has been started from the parent process.
	# Therefore we have to kill the child (tcl process) here.

	KillChild
	exit
}
#E
#---------------------------------------------------------------
proc Read1Item  { fmt } {
#A   read 1 item from input (upto next whitespace)
    
    global id prefsfile

    gets $id string
    set matches [scan $string $fmt var]
    if { $matches < 1 } {
        putsDebug [ format "Error while reading $prefsfile: \nwanted to read: '%s'\nactually read:  '%s'\n" $fmt $string ]
        return 0
    }
    return $var
}

#E
#---------------------------------------------------------------
proc Read1Line  { } {
#A   for ReadJonglPrefs 

    # read 1 line from input (upto, but without newline)

    global id
 
    gets $id dummy
    set dummy [ string range $dummy [ string first "=" $dummy ] end ]
    set var [ string trim $dummy " =" ]

    return $var
}

#E
#---------------------------------------------------------------
proc ReadJonglPrefs { } {
#A

# Variables starting with _ are not read from jongl (C),
# only from prefs.tcl.

#A  globals

    global act1 act2 act3 act4
    global animscale 
    global animbitrate
    global animtype
    global bgrtex
    global bostonmess_phase
		global clipping
    global currentregister
    global delsinglepics
		#    global detail
		global fart_index_in  fart_index_out
    global font
    global fps
    global fq_bounce
    global fq_filter
    global fq_jug
    global fq_max_obj
    global fq_min_obj
    global fq_mplex
    global fq_sort
    global fre_bounce
    global fre_empty_hand
    global fre_jug
    global fre_maxMplex
    global fre_mplex
    global fre_numobj
    global fre_period
    global fre_radius
    global freq 
    global groundname
#    global ground_name  ;# array
#    global ground_file  ;# array
    global hardcopydir 
    global height 
    global hold2 
    global internalInt
    global internalText
    global j2_11
    global j2_active_index
    global j2_decomp
		global j2_gen_pat_but
    global j2_i
    global j2_last_max
    global j2_last_numobj
    global j2_last_period
    global j2_max
    global j2_numobj
    global j2_options_window
    global j2_passing
    global j2_period
    global j2_state
    global j2_x
    global j2_xp
    global jongldir
    global jrc
    global juggler_detail
    global jugglingpattern
    global local 
    global maxfps
    global mousespeed
    global nofork
		global num_ss_hands ; # for multi hand siteswaps
    global object_name
    global object_type
    global pattern 
    global patterndir
    global patfilter
    global patternfilter
    global patternwithpath
    global povray83
    global povraydir 
    global prefsfile
    global randomcolor
		global scatter
    global shade  ;# array
    global shading
    global show_bostonmess_call show_fart_call show_s22j_call show_j2_call show_sstart_call
    global siteswap
    global siteswapdir
    global ss_hands
    global ss_left
    global ss_options
    global ss_options_num
    global ss_right
    global ss_siteswap
    global state ;# array
    global sync 
    global textures 
    global throw_trans
    global timestretch
		global trans_changed_by_fart
    global trans_ground
		global trans_in
		global trans_len_in   trans_len_out   trans_height_in   trans_height_out
		global trans_much_options
		global show_trans_window
		global trans_out
    global trans_siteswap
    global trimpath
    global vrmlobjects 
    global width

    global COMMERCIAL
    global DEBUG
    global id
		
		global _static_siteswap

#E
#A  header
    cd $jongldir
    set id [open $prefsfile r]
    gets $id ;#"JonglPrefsV9\n"
    gets $id 
    gets $id ;# DO NOT CHANGE THIS FILE BY HAND
    gets $id ;# Version
    gets $id
#E
#A  patterns and siteswap

    gets $id 
    gets $id ;#"!  Register Patterns\n"  ;# --------------------------------
    gets $id 
    set bostonmess_phase [Read1Item "bostonmess_phase = %d"]
    gets $id ;# "dontsearch4file = %d"
    set patternwithpath [Read1Line]
    set patternfilter [Read1Line]
    set patfilter $patternfilter
    set hold2 [Read1Item "hold2 = %d"]
    set jugglingpattern [Read1Line]
		set mhssnh [Read1Item "multihandsiteswap = %d"]
		switch $mhssnh {
			0 { set num_ss_hands "[LT 2838]" 
					# Standard (p=pass) 
					} 
			2 { set num_ss_hands "[LT 2831]" } 
			4 { set num_ss_hands "[LT 2832]" } 
			6 { set num_ss_hands "[LT 2833]" } 
			8 { set num_ss_hands "[LT 2834]" } 
			10 { set num_ss_hands "[LT 2835]" } 
		}
		gets $id ; # num_obj
		set object_type [Read1Item "object_type = %d"]
    # see corresponding routine in tcl/objects.tcl: TraceObject
    if { $object_type == -1 } {
        set object_name "[LT 2786]" 
        # otherwise switch gets confused with parameter '-1'
    } else {
        switch $object_type {
            6 { set object_name [LT 2779] } 
            5 { set object_name [LT 2780] } 
            30 { set object_name [LT 2781] } 
            23 { set object_name "[LT 2782]" } 
            3 { set object_name "[LT 2783]" } 
            65 { set object_name "[LT 2784]" } 
            49 { set object_name "[LT 2785]" } 
            default { set object_name "[LT 2786]" }
        }
    }
    set patterndir [Read1Line]
    set show_trans_window [Read1Item "_show_trans_window = %d"]
    set siteswap [Read1Line]
		set _static_siteswap $siteswap
		
    set ss_hands [Read1Line]
#    set ss_left [SS_convert [Read1Item "ss_left = %s"] EXTEND ]
    Convert_ss_hands 

    # keep numerical value for switch:
    set ss_options_num [Read1Item "ss_options = %d"]
    set ss_options [SS_options_convert $ss_options_num EXTEND ]

#    set ss_right [SS_convert [Read1Item "ss_right = %s"] EXTEND ]
    set ss_siteswap [Read1Line]
    Convert_ss_siteswap
    set sync [Read1Item "sync = %d"]
    set throw_trans [Read1Item "throw_trans = %d"]
    set trans_ground [Read1Item "trans_ground_state = %d"]
    set trans_height_in [Read1Item "_trans_height_in = %d"]
    set trans_height_out [Read1Item "_trans_height_out = %d"]
		set trans_in [Read1Line]
    set trans_len_in [Read1Item "_trans_len_in = %d"]
    set trans_len_out [Read1Item "_trans_len_out = %d"]
    set trans_much_options [Read1Item "_trans_much_options = %d"]
		set trans_out [Read1Line]
    set trans_siteswap [Read1Item "trans_siteswap = %d"]
    set trimpath [Read1Item "_trimpath = %d"]
    set pattern $patternwithpath
    TrimPath

    if { $DEBUG & 1 } { putsDebug "--after patterns" }

#E
#A  j2

    gets $id 
    gets $id ;#"\n\n!  Register J2\n"  ;# --------------------------------
    gets $id 
    set j2_11 [Read1Item "_j2_11 = %d"]
    set j2_active_index [Read1Item "j2_active_index = %d" ]
    set j2_decomp [Read1Item "_j2_decomp = %d" ]
    set j2_gen_pat_but [Read1Item "_j2_gen_pat_but = %d" ]
    set j2_i [Read1Item "_j2_i = %s" ]
    if { $j2_i == "-" } { set j2_i {} }
    set j2_max [Read1Item "_j2_max = %d" ]
    set j2_numobj [Read1Item "_j2_numobj = %d" ]
    set j2_options_window [Read1Item "_j2_options_window = %d" ]
    set j2_passing [Read1Item "j2_passing = %d" ]
    set j2_period [Read1Item "_j2_period = %d" ]
    set j2_stateindex [Read1Item "_j2_state = %s" ]
    set j2_state $state($j2_stateindex)
    set j2_x [Read1Item "_j2_x = %s" ]
    if { $j2_x == "-" } { set j2_x {} }
    set j2_xp [Read1Item "_j2_xp = %s" ]
    if { $j2_xp == "-" } { set j2_xp {} }

    set j2_last_max $j2_max
    set j2_last_numobj $j2_numobj
    set j2_last_period $j2_period

#E
#A  freestyle

    gets $id 
    gets $id ;#"\n\n!  Register freestyle\n"  ;# --------------------------------
    gets $id
    set fre_bounce [Read1Item "_fre_bounce = %d" ]
    set fre_empty_hand [Read1Item "_fre_empty_hand = %d" ]
    set fre_jug [Read1Item "_fre_jug = %d" ]
    set fre_maxMplex [Read1Item "_fre_maxMplex = %d" ]
    set fre_mplex [Read1Item "_fre_mplex = %d" ]
    set fre_numobj [Read1Item "_fre_numobj = %d" ]
    set fre_period [Read1Item "_fre_period = %d" ]
    set fre_radius [Read1Item "fre_radius = %f" ]

#E 
#A  settings

    gets $id 
    gets $id ;#"\n\n!  Register Settings\n"  ;# --------------------------------
    gets $id 
    set clipping [Read1Item "clipping = %s" ]
    if { $clipping == "nice"} {
        set clipping [LT 2730]
    } else {
        set clipping [LT 2729]  ;# fast
    }
#    set detail [Read1Item "detail = %d" ]
    set groundname [Read1Item "groundname = %s" ]
    set local [Read1Item "local = %s" ]
    set font [Read1Item "font = %d" ]
    set fps [Read1Item "fps = %d" ]
    set height [Read1Item "height = %d" ]
    set jrc [Read1Item "jrc = %d" ]
    set juggler_detail [Read1Item "juggler_detail = %s" ]
    if { $juggler_detail == "nice"} {
        set juggler_detail [LT 2730]
    } else {
        set juggler_detail [LT 2729]  ;# fast
    }
    set mousespeed [Read1Item "mousespeed = %f" ]
    set randomcolor [Read1Item "randomcolor = %d" ]
    set scatter [Read1Item "scatter = %d" ]
    set shadeindex [Read1Item "shading = %d" ]
    set shading $shade($shadeindex)
    set textures [Read1Item "textures = %d" ]
    set timestretch [Read1Item "timestretch = %f" ]
    gets $id ;# [Read1Item "vrmlobjects = %d" ]
    set vrmlobjects 1 
    set width  [Read1Item "width  = %d" ]

    if { $DEBUG & 1 } { putsDebug "--after graphics" }

#E
#A  export

    gets $id 
    gets $id ;#"\n\n!  Register Export\n"  ;# --------------------------------
    gets $id 
    set animbitrate [Read1Item "ab = %d" ]
    set animtype [Read1Item "animtype = %s" ]
    set animscale [Read1Item "as = %d" ]
    set delsinglepics [Read1Item "delsinglepics = %d" ]
    set freq [Read1Item "freq = %d" ]
    set hardcopydir [Read1Item "hardcopy = %s" ]
    
    gets $id string
    set count [scan $string "povraydir = %s %s" povraydir dummy]
    if { $count == 2 } { set povray83 1 } else { set povray83 0 }

#    set tempdir [Read1Item "temp = %s" ]
    set siteswapdir [Read1Item "siteswapdir = %s" ]

    if { $DEBUG & 1 } { putsDebug "--after export" }

#E
#A  internal
    gets $id 
    gets $id ;#"\n\n!  Internal\n"  ;# --------------------------------
    gets $id 
    set currentregister [Read1Item "currentregister = %s" ]
    set fart_index_in [Read1Item "_ fart_index_in = %d"  ]
    set fart_index_out [Read1Item "_ fart_index_out = %d"  ]
    #    set fq_bounce [Read1Item "_ fq_bounce = %d"  ]
    set fq_filter [Read1Item "_ fq_filter = %d"  ]
    #    set fq_jug [Read1Item "_ fq_jug = %d"  ]
    set fq_max_obj [Read1Item "_ fq_max_obj = %d"  ]
    set fq_min_obj [Read1Item "_ fq_min_obj = %d"  ]
    #    set fq_mplex [Read1Item "_ fq_mplex = %d"  ]
    set fq_sort [Read1Item "fq_sort = %s"  ]
    if { $fq_sort == "alpha" } {
        set fq_sort [LT 2772]
    } else {
        set fq_sort [LT 2773]
    }
    set trans_changed_by_fart [Read1Item "_trans_changed_by_fart = %d"  ]

    if { $DEBUG & 1 } { putsDebug "--after internal" }
#E
#A  develop
        gets $id 
        gets $id ;#"\n\n!  Register Develop\n"  ;# --------------------------------
        gets $id 
        gets $id prefsline
        if { [string index $prefsline 0] == "!" } { 
            set act1 0; 
            set prefsline [string trimleft $prefsline "!"] 
        } else { set act1 1 }
        scan $prefsline "backgroundtexture = %s" bgrtex
        gets $id prefsline
        if { [string index $prefsline 0] == "!" } { 
            set act2 0
            set prefsline [string trimleft $prefsline "!"] 
        } else { set act2 1 }
        scan $prefsline "internalInt = %d" internalInt
        gets $id prefsline
        if { [string index $prefsline 0] == "!" } { 
            set act3 0
            set prefsline [string trimleft $prefsline "!"] 
        } else { set act3 1 }
        scan $prefsline  "InternalText = %s" internalText
        gets $id prefsline
        if { [string index $prefsline 0] == "!" } { 
            set act4 0
            set prefsline [string trimleft $prefsline "!"] 
        } else { set act4 1 }
        scan $prefsline "maxfps = %d" maxfps

        set nofork [Read1Item "nofork = %d" ]
        set show_bostonmess_call [Read1Item "show_bostonmess_call = %d" ]
        set show_fart_call [Read1Item "_show_fart_call = %d" ]
        set show_j2_call [Read1Item "_show_j2_call = %d" ]
        set show_s22j_call [Read1Item "show_s22j_call = %d" ]
#        set show_sstart_call [Read1Item "_show_sstart_call = %d" ]
#E
    close $id

    if { $DEBUG & 1 } { putsDebug "Read jongl.prefs" }

}

#E
#----------------------------------------
proc ResetSS_hands { } {
#A   for Reset button at siteswap-hands frame

    global num_jug ss_hands   num_obj  trans_changed_by_fart

    set ss_hands ""

    for { set h 0 } { $h < [expr 2*$num_jug] } { incr h } {
        append ss_hands "csp**bo**Z+00"
    }
    
    Convert_ss_hands
    TraceSS_options bla bla bla

}
#E
#----------------------------------------
proc ResetSS_siteswap { } {
#A   for Reset button at siteswap-siteswap frame

    global ss_len ss_siteswap   num_obj   trans_changed_by_fart

    set ss_siteswap ""
    for { set t 0 } { $t < $ss_len } { incr t } {
        append ss_siteswap "csp**bo**Z+00"
    }

    Convert_ss_siteswap
    TraceSS_options bla bla bla
    
}
#E
#----------------------------------------
proc SeparateJ2throws { in_pattern } {
#A   separate transition throws from j2 pattern; set trans_in & trans_out

		global trans_in  trans_out

		# regsub ?switches? exp string subSpec varName
		regsub -all {[\<\>\|(),]} $in_pattern "" no_special_chars
		# remove leading and traling whitespace:
		set j2_pattern [string trim $no_special_chars]

		set lindex [string first " " $j2_pattern]                
		if { $lindex == -1 } { 
				set lindex 0 
				set trans_in ""
		} else {
				set trans_in [ string range $j2_pattern 0 $lindex ]
				set trans_in [ string trim $trans_in ]
		}
		set rindex [string last " " $j2_pattern]
		if { $rindex == -1 } { 
				set rindex end 
				set trans_out ""
		} else {
				set trans_out [ string range $j2_pattern $rindex end ]
				set trans_out [ string trim $trans_out ]
		}
		# get pattern without transitions:
		set j2_pattern [string range $j2_pattern $lindex $rindex]
		# trim once more:
		set j2_pattern [string trim $j2_pattern]

		return $j2_pattern
}
#E
#----------------------------------------				
proc Setup { } {
#A setup jongl.prefs after 1st invokation

  global SETUP_FILE local jongldir patterndir j_title

#A make window	
	wm withdraw .
	set w .setup
	toplevel $w
	wm withdraw .setup
	wm title .setup "Jongl Setup"
	wm protocol .setup WM_DELETE_WINDOW { destroy .setup }
	#$w config -bg gray
	
	# set padding
	set p 7
	
	# pack [ label $w.t10 -text "Jongl setup" ]
	pack [ label $w.t20 -text "Please select language" ] -padx $p
	
	tk_optionMenu $w.lang local_setup "deutsch" "english" "francais" "espanol" "catala"
	# see same menu at approx. line 3426
	set local_setup "english"  ; # does not seem to work
	pack $w.lang  -anchor w -expand true -fill x -padx $p -pady $p -expand 1
	
	pack [ label $w.t30 -text "Jongl writes nothing into the registry." ]  -padx $p
	pack [ label $w.t40 -text "It can be moved, copied or deleted without problems." ]  -padx $p
	pack [ label $w.t50 -text "Read the complete description of all features, " ]  -padx $p
	pack [ label $w.t52 -text "changes, options and files in doc/spec.html." ]  -padx $p
	
	button $w.ok -text "    OK    "  -command { 
		
		set patterndir $jongldir/m
		set local $local_setup
		set patternwithpath $jongldir/m/5
		set jugglingpattern $patternwithpath
		TrimPath
		# write new language & correct pattern directory to jongl.prefs
		WriteJonglPrefs $jugglingpattern 1

		# tell jongl.c that the language has been changed:
		SetLanguage $local 
	
		# write control file:
		set id [open $SETUP_FILE w]
		puts $id [ format "%s\n" $j_title ]
		close $id
		
#		putsDebug "Setup done. Language has been set to: $local."
		destroy .setup
  }
	pack $w.ok -pady $p -padx $p
	
	# center current window on screen:
	# (siehe S. 299 Ousterhout)
	set xpos [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	- [winfo vrootx [winfo parent $w]]]
	set ypos [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$xpos+$ypos
	
	update idletasks
	wm deiconify .setup
	tkwait window .setup
	#E
	
	return
}
#E
#----------------------------------------
proc ShowFrame { show update} {
#A   switch between register tabs and update content

    global COMMERCIAL w  wt
    global avoid_throws
    global currentregister
    global buttonlist
    global obb mhss
    global num_ss_hands
    global sync  j2_passing
		global ss_options_num
		global num_obj
		global trans_changed_by_fart    throw_trans
    
#		putsDebug ShowFrame
		
    if { $show == "current" } { set show $currentregister }
    
		#A update appearance of register tabs
		
    foreach del $buttonlist {
        pack forget .jongl.$del
        if { [ Check4Mac ] } {
            .jongl.register.$del configure -default normal
        } else {
            .jongl.register.$del configure -relief raised
        }
    }
    pack forget .jongl.obb 
    pack forget .jongl.mhss 
    pack .jongl.$show -fill both -expand yes -padx 2 -pady 2
    if { [ Check4Mac ] } {
        .jongl.register.$show configure -default active
    } else {
        .jongl.register.$show configure -relief sunken
    }
		#E
		
    if { $update } { 
        set currentregister $show 
        if { $currentregister == "j2" ||
             $currentregister == "ss" } {
            # show multi hand siteswap options:
            set avoid_throws [ AvoidThrows [ MHSS_num_hands ] ] 
            if { [ llength $avoid_throws ] == 1 } {
                if { $num_ss_hands == "[LT 2838]" } {
                    # standard
                    set avoid_text "[LT 2844]"
                } elseif { $num_ss_hands == "[LT 2831]" } {
                    # solo mode
                    set avoid_text "[LT 2845]"
                } else {
                    set avoid_text "" 
                }
            } else {
							if {  [ MHSS_num_hands ] > 4 } {
								set add_text "\n([LT 2842])"
							} else {
								set add_text ""
							}
							if { $currentregister == "j2" } {
								set avoid_text [ format "[LT 2837] %s%s" [ join $avoid_throws ] $add_text ]
							} else {
								set avoid_text [ format "[LT 2836] %s%s" [ join $avoid_throws ] $add_text ]
							}
            }
            $w.mhss.label configure -text $avoid_text
            pack $mhss -expand 1 -fill x -padx 3 -pady 3
						if { $currentregister == "ss" || $currentregister == "j2" } {
							# update transition text:
							TraceSS_options bla bla bla
						}
					} else { ;  # j2 || ss
						ShowTransWindow off
					}

        if { $currentregister == "j2"  } { 
            if { $j2_passing == 1 } {
                ShowThrowTransButton 1
            } else {
                ShowThrowTransButton 0
            }
        } else {
            J2_options_window off 
        }

        if { $currentregister == "pat" || 
             $currentregister == "ss" || 
             $currentregister == "j2" ||
             $currentregister == "fre" } {
            # show object selection buttons:
            pack $obb -expand 1 -fill x -padx 3 -pady 3
        }
				if { $ss_options_num == 2 } {
					ShowThrowTransButton 0
				} else {
					ShowThrowTransButton 1
				}					
    } ; # if { $update }
		
		updateSyncButton compute
		
		# show transition window
		if { $throw_trans } {
			if { [ ShowTransWindow on ] != -1 } {
				## fart: changeAppearance show
			}
		}
		
}

#E
#----------------------------------------
proc ShowThrowTransButton { show_trans } {
#A   en-/disable checkbox "throw transitions" 

    global w wt   show_trans_window

   TraceThrowTrans $show_trans  0 0

   set trans_button $w.mhss.f5.f3.throw_trans 
   if { $show_trans } {
        $trans_button configure -state normal
   } else {      
        $trans_button configure -state disabled
   }

}
#E
#----------------------------------------
proc ShowTransWindow { show } {
#A show / hide / toggle transition window

    # returns -1 if not ready

    # globals for trans_options.tcl:
    global trans_ground trans_siteswap  xpos ypos  w wt
		global trans_len_in   trans_len_out   trans_height_in   trans_height_out
    # globals for this:
    global show_trans_window  sync  

		# main GUI window not initialized -> no secondary window
		# (because we don't know where to place it)
		if { $xpos == -1 } { return -1 }
		
    switch $show {
        "on" {
					if { $show_trans_window >1  || $sync } { return -1 }
						# TODO: special options for sync patterns
            set show_trans_window 1

            ## fart: InitFart
						#####set init_fart 20060429 
						#####source "tcl/trans_options.tcl" 
        }
        "off" {
            set show_trans_window 0
#            $w.j2.b.j2_options configure -text "[LT 2801]"
            if { [ winfo exists $wt ] } {
                destroy $wt 
            }
        }
        "toggle" {
            if { ! $show_trans_window } { 
                ShowTransWindow on
            } else {
                ShowTransWindow off
            }
        }
    }
		return 0
}

#E
#---------------------------------------------------------------
proc SS_convert { handmov flag } {
#A   convert between c,b,.. and cascade, backcross,
    if { $flag == "REDUCE" } {
        set ss_first [ string first "(" $handmov ]
        if { $ss_first == -1 } { set ss_first 0 } else { incr ss_first }
        set ss_last [ string last ")" $handmov ]
        if { $ss_last == -1 } { set ss_last end } else { incr ss_last -1 }
        set short [ string range $handmov $ss_first $ss_last ]
        return $short
    } else {
        switch $handmov {
            c { return [LT 2615] }
            C { return [LT 2616] }
            f { return [LT 2617] }
            b { return [LT 2618] }
            S { return [LT 2619] }
            default { return "Error in jongl.prefs: ss_*" }
        }
    }
}
#E
#----------------------------------------
proc SS_convert_spbo { handmov flag } {
#A   convert between spin/bounce and LT
    if { $flag == "REDUCE" } {
        if { $handmov == [LT 2814] } { return "sp-1bo**" }
        if { $handmov == [LT 2815] } { return "sp00bo**" }
        if { $handmov == [LT 2816] } { return "sp+1bo**" }
        if { $handmov == [LT 2817] } { return "sp+2bo**" }
        if { $handmov == [LT 2818] } { return "sp+3bo**" }
        if { $handmov == [LT 2819] } { return "sp+4bo**" }
        if { $handmov == [LT 2803] } { return "sp**bo+1" }
        if { $handmov == [LT 2804] } { return "sp**bo+2" }
        if { $handmov == [LT 2805] } { return "sp**bo+3" }
        if { $handmov == [LT 2810] } { return "sp**bo-1" }
        if { $handmov == [LT 2811] } { return "sp**bo-2" }
        if { $handmov == [LT 2812] } { return "sp**bo-3" }
        # else return default
        return "sp**bo**"
    } else {
        if { $handmov == "sp-1bo**" } { return [LT 2814] } 
        if { $handmov == "sp00bo**" } { return [LT 2815] } 
        if { $handmov == "sp+1bo**" } { return [LT 2816] } 
        if { $handmov == "sp+2bo**" } { return [LT 2817] } 
        if { $handmov == "sp+3bo**" } { return [LT 2818] } 
        if { $handmov == "sp+4bo**" } { return [LT 2819] } 
        if { $handmov == "sp**bo+1" } { return [LT 2803] } 
        if { $handmov == "sp**bo+2" } { return [LT 2804] } 
        if { $handmov == "sp**bo+3" } { return [LT 2805] } 
        if { $handmov == "sp**bo-1" } { return [LT 2810] } 
        if { $handmov == "sp**bo-2" } { return [LT 2811] } 
        if { $handmov == "sp**bo-3" } { return [LT 2812] } 
        # else return default (sp**)
        return [LT 2802]  
    }
}
#E
#----------------------------------------
proc SS_convert_Z { handmov flag } {
#A   convert between Z+90 and LT
    if { $flag == "REDUCE" } {
        if { $handmov == [LT 2820] } { return "Z+90" }
        if { $handmov == [LT 2821] } { return "Z+45" }
        if { $handmov == [LT 2823] } { return "Z-45" }
        if { $handmov == [LT 2824] } { return "Z-90" }
        # else return default
        return "Z+00"
    } else {
        if { $handmov == "Z+90" } { return [LT 2820] }
        if { $handmov == "Z+45" } { return [LT 2821] }
        if { $handmov == "Z-45" } { return [LT 2823] }
        if { $handmov == "Z-90" } { return [LT 2824] }
        # else return default (Z+00)
        return [LT 2822]  
    }
}
#E
#----------------------------------------
proc SS_hands { framename buttonname } {
#A   generate 3 buttons for throw type, spin/bounce count and Z-rotation

# Create a frame called $framename
# with buttons called $buttonname (casc,..) and $bounce_$buttonname (bounce or spin)
# and variables called ss_$buttonname (casc,...) and ss_bounce_$buttonname 

    global lightblue
#    global ss_$buttonname ss_bounce_$buttonname ss_z_$buttonname

    set ha [ frame $framename -bg $lightblue ]

#          tk_optionMenu $ha.left ss_left [LT 2615] [LT 2616] [LT 2617] [LT 2618] [LT 2619] 
#          f and S are currently not implemented in s22j

      # casc, backcross, or else
      tk_optionMenu $ha.$buttonname ss_$buttonname [LT 2615] [LT 2616] [LT 2618] 
      pack $ha.$buttonname -fill y -expand yes -side left 

      # throw or bounce:
      tk_optionMenu $ha.bounce_$buttonname ss_bounce_$buttonname \
        [LT 2802] \
        [LT 2814] [LT 2815] [LT 2816] [LT 2817] [LT 2818] [LT 2819] \
        [LT 2803] [LT 2804] [LT 2805] \
        [LT 2810] [LT 2811] [LT 2812] 
      pack $ha.bounce_$buttonname -fill y -expand yes -side left 

      # Z-rotation of object:
      tk_optionMenu $ha.z_$buttonname ss_z_$buttonname \
        [LT 2822] [LT 2820] [LT 2821] [LT 2823] [LT 2824]
      pack $ha.z_$buttonname -fill y -expand yes -side left


 }
#E
#----------------------------------------
proc SS_options_convert { ssopt flag } {
#A   convert verbose siteswap options to indices

    if { $flag == "REDUCE" } {
        # I don't know why switch does not work here.
        if { $ssopt == "[LT 2806]" } {   
            # throw
            return 0
        } elseif { $ssopt == "[LT 2807]" } {
            # throw per hand
            return 1
        } elseif { $ssopt == "[LT 2808]" } {
            # throw per siteswap
            return 2
        } elseif { $ssopt == "boston mess" } {
            # call external program "bostonmess"
            return 3
        } else { 
            putsDebug [ format "Illegal option in SS_options_convert: %d"  $ssopt ]
        }
    } else {
        switch $ssopt {
            0 { return [LT 2806] } 
            1 { return [LT 2807] }
            2 { return [LT 2808] }
						3 { return "boston mess" }
        }
    }
}
#E
#----------------------------------------
proc sync2async { ss } {
#A convert sync pattern to async pattern: output is a LIST !

  # throws with x at even positions: +=1
	# throws with x at odd positions: -=1
	# counting starts with 0
			
	set sst [ TrimSS $ss x ]
	set ssl [ makeListFromString $sst ] ; # strip spaces
	while {1} {
		set x [ lsearch -exact $ssl 33 ] ; # 33 = 'x'
		if { $x == -1 } { break } ; # found none
		set x1 [ expr $x -1]
		set throw [ lrange $ssl $x1 $x1]
		if { [ Odd $throw ] } { 
			# no crossed throw of odd height allowed 
			return -1 
		}
		if { [ Odd $x ] } {
			# index of x is odd -> number before x is even -> add one to the count
			# 8x -> 9
			set ssl [ lreplace $ssl $x1 $x [ expr [ hex2dec $throw ] +1]  ] 
		} else {
			# subtract one: (8x -> 7)
			set ssl [ lreplace $ssl $x1 $x [ expr [ hex2dec $throw ] -1]  ] 
		}
	} ; # while
	
	return $ssl
}
#E
#----------------------------------------
proc TraceFreestyle { varname elemname operation } {
#A   don't allow patterns with not enough objects or too short period

    global fre_jug fre_numobj fre_mplex fre_period
    global w

    if { $varname == "fre_jug" } {
		## at least 2J+1 objects
        if { $fre_jug > 1 && $fre_numobj < [ expr $fre_jug*2+1 ] } {
            set fre_numobj [ expr $fre_jug*2+1 ]
        }
    } elseif { $varname == "fre_period" } {
		## at least period = 2*obj
        if { $fre_period < [ expr 2*$fre_numobj ] } {
            set fre_numobj [ expr $fre_period/2 ]
        }
		## at least 2J+1 objects
        if { $fre_jug > 1 && $fre_numobj < [ expr $fre_jug*2+1 ] } {
            set fre_jug [ expr $fre_numobj/2 ]
            if { $fre_jug == 0 } {
                set fre_jug 1
            }
        }
    } elseif { $varname == "fre_numobj" } {
		## at least 2J+1 objects
        if { $fre_numobj < [ expr $fre_jug*2+1 ] } {
            set fre_jug [ expr ($fre_numobj-1) / 2 ]
            if { $fre_jug == 0 } {
                set fre_jug 1
            }
        }
		## at least period = 2*obj
        if { $fre_period < [ expr 2*$fre_numobj ] } {
            set fre_period [ expr 10*(1+$fre_numobj/5) ]
        }
    }

    ## disable radius when only 1 juggler is selected:
    if { $fre_jug == 1 } {
        $w.fre.r1.sliders.r4.radius configure -state disabled
    } else {
        $w.fre.r1.sliders.r4.radius configure -state normal
    }

    ## disable maxMplex when no multiplex prob. is selected
    if { $fre_mplex == 0 } {
        $w.fre.r1.sliders.maxMplex configure -state disabled
    } else {
        $w.fre.r1.sliders.maxMplex configure -state normal
    }
}
#E
#---------------------------------------------------------------
proc TraceJ2 { varname elemname operation } {
#A   update text on "generate pattern" button

	global j2_gen_pat_but  w  ww  auto_change  j2_passing f_both

	if { $operation == "w" } {
		set j2_gen_pat_but 2
	}

	if { $auto_change } {
		# without this, the deselect commands below
		# would change the state once more
		set auto_change 0
	} else {
		if { $varname == "sync" } {
			set auto_change 1
		}
		if { $varname == "j2_passing" } {
			set auto_change 1
			# switch off "sync"
			#$f_both.sync deselect
		}
	}
	
	switch $j2_gen_pat_but  {
		1 {
			# up-to-date
			$w.j2.b.gen configure -text "[LT 2752]"
		}
		2 {
			# outdated
			$w.j2.b.gen configure -text "[LT 2847] --> [ LT 2900]"
		}
	}	
}
#E
#---------------------------------------------------------------
proc TraceLocal { varname elemname operation } {
#A   display message 

# This is LT 2747:

    tk_messageBox -icon info -type ok -title Info\
        -message "Die Sprache ndert sich erst beim nchsten Start.\n\
\nThe language will change with the next start.\n\
\nLa langue changera au prochain dmarrage.\n\
\nEl idioma se cambiara la proxima que empiece.\n\
\nL'idioma canviar el proper cop que engegueu." 

}

#E
#---------------------------------------------------------------
proc TraceMHSS { varname elemname operation } {
#A   deal with multi handed site swaps

  global num_obj  trans_changed_by_fart
	
	# update state and transitions
	TraceSS_options bla bla bla

	# update current register:
	ShowFrame current true

	# updateSyncButton compute
}
#E
#---------------------------------------------------------------
proc TraceObject  { varname elemname operation } {
#A   convert object numbers and descriptions

    global object_type

    set object_type -17
    upvar $varname v

# see corresponding routine in tcl/prefs.tcl: ReadJonglPrefs
    if { $v == [LT 2779] } {
        set object_type 6
    } elseif { $v == [LT 2780] } {
        set object_type 5
    } elseif { $v == [LT 2781] } {
        set object_type 30
    } elseif { $v == "[LT 2782]" } {
        set object_type 23
    } elseif { $v == "[LT 2783]" } {
        set object_type 3
    } elseif { $v == "[LT 2784]" } {
        set object_type 65
    } elseif { $v == "[LT 2785]" } {
        set object_type 49
    } else {
        set object_type -1
    }        
# does not work with switch $v 

}

#E
#---------------------------------------------------------------
#---------------------------------------------------------------
proc TraceSS_options { varname elemname operation } {
#   make frames for and compute ss_hands and ss_siteswap
#A  compute state and transitions of siteswap pattern

    global w lightblue trans_text  throw_trans
    global ss_options   ss_options_num  ss_hands   ss_siteswap
    global siteswap  trans_in   trans_out   trans_changed_by_fart
    global num_jug   ss_len   num_ss_hands  num_obj
		global currentregister j2_passing sync bostonmess_phase

#		putsDebug TraceSS_options
		
    set show_trans 0
		set fractional_throws 0
		set mhss_hands  [ MHSS_num_hands ]
		
		if { $currentregister != "ss"  && $currentregister != "j2" } return
		
		#A  compute no. of jugglers:
			
			if { $mhss_hands <=2 } {
				# compute no. of hands only if 2-handed / standard / solo pattern
				
				#  remove multiplex, spaces and sync:
				regsub -all {[,x\[\] ()<>|]} $siteswap "" ss_trimmed
				set ss_len [string length $ss_trimmed]
				
				if { [ regexp {[.]} $ss_trimmed ] == 1 } {
					set fractional_throws 1
				}
				
				if { $num_ss_hands == "[LT 2831]" } { 
					# solo mode
					set solo 1 ; # make solo patterns containg "p" possible
					set num_jug 1
				} else {
					# either standard mode (p=pass)
					# or multihanded mode
					set solo 0
					if { [ regexp {[A-Zp]} $ss_trimmed ] == 0 } {
						set num_jug 1
					} else { 
						regsub -all {[a-z]} $ss_trimmed "" ss_count
						set len [string length $ss_count]
						# at least 2 people:
						set max B
						for { set i 0 } { $i < $len } { incr i } {
							if { [ string index $ss_count $i ] > $max } {
								set max [string index $ss_count $i]
							}
						}
						# atoi:
						set num_jug [ expr [ hex2dec $max ] -9 ]  ;# hex2dec B = 11 -> 2 Jugglers 
					}
				}
			} else { ; # mhss_hands >2
				set num_jug [ expr $mhss_hands / 2 ]
			}
			
			#E
				
			if { $currentregister != "j2" } {
				# now only "ss" mode:
			
				#A set period and texts
				
				set transition_text " "
				set status_text " "
				if { $fractional_throws == 1 } {
					if { $mhss_hands <= 2 } {
						# "might work" (standard and solo mode with 1...N jugglers)
						set transition_text "[LT 2846]"
					} else {
						# "invalid" (multihanded site swap)
						set transition_text "[LT 2825]"  
					}
					set period 0
				} else { ; # non fractional throws
					
					if { $mhss_hands == 2 && [ regexp {[wxyz]} $siteswap ] == 1 } {
						# 'x' only allowed in standard mode
						set transition_text "[LT 2870]"  ; # "higher than v"
						set period 0 
		} elseif { [ regexp {[*]} $siteswap ] == 1 } {
			set transition_text "[LT 2904]" ; # contains * 
			set period 0
		} elseif { $num_jug == 1 || $mhss_hands > 2 } {
			set ssl [ validSS $siteswap ]
			# ssl does not contain spaces and "x" -> length might be shorter!
			if 	{ $ssl  == -1 } { 
				set transition_text "[LT 2825]"  ; # "invalid"
				set period 0
			} else {
				set period [ llength $ssl ]
			}
		} else { ; # num_jug >1
			# enable setting of texts below
			set period 1
		}
				}  ; # fractional_throws != 1
				
				#E
				
				if { $period > 0 } {
					if { $num_ss_hands == "[LT 2838]" && $num_jug > 1  } {
						# no Transitions or Status if >1 juggler in "standard" mode
						set status_text " "
						set transition_text [ format "[LT 2612]" $num_jug ]
					} else {
						
						#A  compute status of current ss pattern
						
						if { [ string last "." $siteswap ] != -1 } { 	; # fractional heights
							set transition_text "[LT 2828]"
							set status_text "[LT 2829]"
						} else {
							set bit 0
							set pos $period
							set stat 0
							for { set i 0 } { $i < $period } { incr i } {
								# pos. in pattern, calculated from right end
								set bit [ expr [ lrange $ssl $i $i ] - $pos ]
								while { $bit>=0 } {
									if { $bit>=0 } { 
										# set bit
										set stat [ expr $stat + pow (2,$bit) ] 
									}
									incr bit -$period ; # subtract period
								}
								# next digit is 1 pos. closer to the end
								incr pos -1
							}
							# stat contains e.g. "31.0"
							set stat_dec [format "%.0f" $stat]
							set stat_bin [write_binary $stat]
							set status_text [format [LT 2826] $stat_bin $stat_dec]
							#E
							
							#  compute transition from ground state to pattern
							
							# compute number of objects
							set num_obj 0
							for { set i 0 } { $i < $period } { incr i } {
							incr num_obj [lrange $ssl $i $i]
						}
						set num_obj [ expr $num_obj / $period ]
						
						set groundstate [ expr pow(2,$num_obj)-1 ]  ; # e.g. = "15.0"
						
						if { $trans_changed_by_fart == 0 } {
							#A				
							set trans_in ""
							set trans_out ""
							if { $stat == $groundstate } {
								set transition_text [format [LT 2827] $num_obj] ; # ground state pattern
								set show_trans 1
								makeGroundPattern $num_obj
							} else {
								# compute transition from ground state to current pattern
								set nul 0 ; # counts 0s
								set st $stat
								while {$st>0} {
									if {$nul==0} {
										if { ! [ Odd $st ] } { 
											# found 1st zero from right side
											set nul 1 
										}
									} else {
										if { ! [ Odd $st ] } { 
											# found one more zero from right side
											incr nul
										} else {
											# add throw to current transition
											set trans_in [ format "%s%s" $trans_in [dec2hex [expr $num_obj+$nul]]]
										}
									}
									set st [ expr int($st/2)]
								}
								
								# special handling for sync pattern
								if { $sync } {
									if { [ Odd [ string length $trans_in ] ] } {
										# length of transition in sync mode is odd -> add one ground state throw
										set trans_in [ format "%s%s" [dec2hex $num_obj ] $trans_in ]
									}
									set trans_in [ async2sync $trans_in ]
								}
								
								#A  compute trans. from cur. pat. to ground state
								set st [expr int($stat)]
								while { $st > $groundstate } {
									if { [ Odd $st ] } {
										# here is the next throw
										set throw [expr int([nextZero $st] ) ] 
										incr st [expr int(pow(2,int($throw)))] ; # update status
									} else {
										# no LSB -> no throw
										set throw 0
									}
									set trans_out [ format "%s%s" $trans_out [dec2hex $throw]]
									set st [ expr int($st/2)]
								}
								
								# special handling for sync pattern
								if { $sync } {
									if { [ Odd [ string length $trans_out ] ] } {
										# length of transition in sync mode is odd -> add one ground state throw
										set trans_out [ format "%s%s" $trans_out [dec2hex $num_obj ] ]
									}
									set trans_out [ async2sync $trans_out ]						
								}
								
								set transition_text [ makeTransitionLine ]
								
								set show_trans 1
								#E
							} ; # not groundstate pattern
							#E
						} ; # trans_changed_by_fart
					} ; # end of [ validSS $siteswap ]
	     } ; # end of {  ! $num_jug > 1 }  
	  } ; # end of { $period > 0 }
		
		set trans_text $w.ss.f4.st.transitions
		$trans_text configure -text $transition_text
		$w.ss.f4.st.status configure -text $status_text
	} ; # end of { $currentregister != "j2" }
	
  # reduce verbose options to numbers:
	set ss_options_num [SS_options_convert $ss_options REDUCE]

	# check if any GUI elements have to be updated
	needUpdate $show_trans
	
	############ deal with special throws ###############
	
  switch  $ss_options_num {
	0 { 
# standard throw
	    pack forget $w.mhss.hands
	    pack forget $w.mhss.ss
			pack forget $w.mhss.bome
# Don't set these values, just make them invisible with ss_options:
#            set ss_hands "csp**bo**Z+00"
#            set ss_siteswap "csp**bo**Z+00"

		ShowThrowTransButton 1 

	}
	1 {
#A    throw per hand
	    destroy $w.mhss.hands
	    pack forget $w.mhss.ss
			pack forget $w.mhss.bome

#A   create widgets:
	   set hands [ frame $w.mhss.hands -bg $lightblue -relief groove -bd 2]
	      frame $hands.fr -bg $lightblue 
					set hands_lbl [ frame $hands.fr.ss_lbl -bg $lightblue]
					set hands_btn [ frame $hands.fr.ss_btn -bg $lightblue]

					switch $currentregister {
						"ss"  {
							set no_jug $num_jug
						} 
						"j2" {
							set no_jug $j2_passing
						}
					}

					for { set j 1 } { $j <= $no_jug } { incr j } {
		    
							if { $no_jug > 1 } {
									set n "[LT 2813] [format %c [expr $j + 64]]: "
							} else {
									set n ""
							}
							pack [label $hands_lbl.left_$j -text "$n [LT 2613]" -bg $lightblue] -anchor e -fill y -expand true
							SS_hands $hands_btn.btn_left_$j left_$j
							pack $hands_btn.btn_left_$j -fill y -anchor w -expand yes -pady 1
																
							pack [label $hands_lbl.right_$j -text "[LT 2614]" -bg $lightblue] -anchor e -fill y -expand true
							SS_hands $hands_btn.btn_right_$j right_$j
							pack $hands_btn.btn_right_$j -fill y -anchor w -expand yes -pady 1
  
					}
					pack $hands_lbl -side left -expand true -fill both  -padx 10 -pady 10
					pack $hands_btn -side right -expand true -fill both -padx 10 -pady 10
  
         set ss_t [ frame $hands.ss_t -bg $lightblue ]
           pack [label $ss_t.experimental -text "[LT 2842]" -bg $lightblue ] -padx 7 -pady 7 -side left
           pack [ button $ss_t.reset -text "[LT 2106]" -command ResetSS_hands ] -padx 7 -pady 7 -side bottom 
         pack $ss_t -side bottom
	    pack $hands.fr -expand true -fill both 
	  pack $hands -after $w.mhss.f5 -expand true -fill both  -padx 10 -pady 10
#E            
#A   compute ss_hands:
	    # ss_hands contains types of throws for all hands of all jugglers 
	    # L1 R1 L2 R2 L3 R3 . . . 

	    set ss_hands ""
	    
	    for { set j 1 } { $j <= $no_jug } { incr j } {

				global ss_left_$j ss_bounce_left_$j ss_z_left_$j
				global ss_right_$j ss_bounce_right_$j ss_z_right_$j
				
				# Other way round: proc Convert_ss_hands {}
				
				# left:
				# remove indices: ($ss_left_$j does not work)
				set ss_left [set ss_left_$j]
				set ss_bounce_left [set ss_bounce_left_$j]
				set ss_z_left [set ss_z_left_$j]
				
				append ss_hands \
		    [SS_convert $ss_left REDUCE] \
		    [SS_convert_spbo $ss_bounce_left REDUCE] \
		    [SS_convert_Z $ss_z_left REDUCE] \
				
				# right:
				# remove indices:
				set ss_right [set ss_right_$j]
				set ss_bounce_right [set ss_bounce_right_$j]
				set ss_z_right [set ss_z_right_$j]
				
				append ss_hands \
		    [SS_convert $ss_right REDUCE] \
		    [SS_convert_spbo $ss_bounce_right REDUCE] \
		    [SS_convert_Z $ss_z_right REDUCE] \
		
	    }
#            puts $ss_hands
#E

		ShowThrowTransButton 1 

#E
	}
	2 {
#A     throw per siteswap
	    
	    pack forget $w.mhss.hands
			pack forget $w.mhss.bome
	    destroy $w.mhss.ss
			
			#    create widgets and compute ss_siteswap:
	    set ss_siteswap ""
	    # remove feed, passing, multiplex, spaces and sync:
			switch $currentregister {
				"ss"  {
					set ss_trimmed [ TrimSS $siteswap 0 ]
				} 
				"j2" {
					set ss_trimmed [ TrimSS [ SeparateJ2throws [ selection get ] ] 0 ]
				}
			}
			# exp has to be in {[ ]}
	    set ss_len [string length $ss_trimmed]
			
	    set ss [ frame $w.mhss.ss -bg $lightblue -relief groove -bd 2]
			frame $ss.fr -bg $lightblue
			set ss_lbl [ frame $ss.fr.ss_lbl -bg $lightblue]
			set ss_btn [ frame $ss.fr.ss_btn -bg $lightblue]
			for { set i 0; set t 1 } { $i < $ss_len } { incr i; incr t } {
		    global ss_$t ss_bounce_$t ss_z_$t
		    if { [ string index $ss_trimmed [ expr $i + 1 ] ] == "." } {
					# process non integer throws:
					set lbl [ string range $ss_trimmed $i [ expr $i + 2 ] ]
					incr i 2
		    } else {
					set lbl [string index $ss_trimmed $i]
		    }
		    # numbering of buttons starts with 1!
		    pack [label $ss_lbl.lbl_$t -text "[LT 2809] $t:  $lbl" -bg $lightblue ] -anchor e -fill y -expand true
		    SS_hands $ss_btn.btn_$t $t
		    pack $ss_btn.btn_$t -fill y -anchor w -expand true -pady 1
				
		    # remove indices: ($ss_$t does not work)
		    set ss_ [set ss_$t]
		    set ss_bounce [set ss_bounce_$t]
		    set ss_z [set ss_z_$t]
		    # Other way round: proc Convert_ss_siteswap {}
		    append ss_siteswap \
				[SS_convert $ss_ REDUCE] \
				[SS_convert_spbo $ss_bounce REDUCE] \
				[SS_convert_Z $ss_z REDUCE] 
			}
			pack $ss_lbl -side left -expand true -fill both  -padx 10 -pady 10
			pack $ss_btn -side right -expand true -fill both -padx 10 -pady 10
			
      set ss_t [ frame $ss.ss_t -bg $lightblue ]
			pack [label $ss_t.experimental -text [LT 2842] -bg $lightblue ] -padx 7 -pady 7 -side left
			pack [ button $ss_t.reset -text "[LT 2106]" -command ResetSS_siteswap ] -padx 7 -pady 7 -side bottom 
      pack $ss_t -side bottom
			pack $ss.fr -expand true -fill both 
			
			pack $ss -after $w.mhss.f5 -expand true -fill both  -padx 10 -pady 10
		
		# disable transitions (because pattern with transitions has more throws
		# than are defined here)
		ShowThrowTransButton 0 
#E
	}
	3 {
		#A  bostonmess
		
		pack forget $w.mhss.hands
		pack forget $w.mhss.ss
		destroy $w.mhss.bome
		
		set bome [ frame $w.mhss.bome -bg $lightblue -relief groove -bd 2]
		  set bm [frame $bome.fr -bg $lightblue] 
			pack [ label $bm.lbl -text "phase"  -bg $lightblue ] 
      pack [scale $bm.phase -variable bostonmess_phase -orient horizontal \
                -from 0 -to [fac_minus_1 $num_obj ] -showvalue true  -bg $lightblue ] \
                -fill x -expand true -side left -padx 5 -pady 5
		  pack $bm -expand true -fill x
		pack $bome -after $w.mhss.f5 -expand true -fill both  -padx 10 -pady 10
		#E
	}
	default { 
	    putsDebug format [ "Unknown option in TraceSS_options: %d" $ss_options_num ]
	}
    }
}
#E
#---------------------------------------------------------------
#---------------------------------------------------------------
proc TraceTextures  { varname elemname operation } {
#A   define values for ground selection

# Depending on the value of "textures" there are more or
# less possible grounds in pano/

    global textures
		
		# reload data
		selectPano init
		
		# find ground
		selectPano check
		
		selectPano display
}
#E
#---------------------------------------------------------------
proc TraceThrowTrans { varname elemname operation } {
#A   show or hide transition input window

    global wt  trans_ground  trans_siteswap  throw_trans  
		global show_trans_window  currentregister  w

    # default call from system:
    # $varname == throw_trans
    # $elemname ==
    # $operation == w
    
    # special call as a query:
    # elemname == ask

		## fart: die nchsten 2 und die 2 pack ausblenden
		
    set trans_boxes $w.mhss.f5.r4
    set trans_button $w.mhss.f5.f3.throw_trans
    
    if { $varname == 0 || $throw_trans == 0  } {
			ShowTransWindow off
			pack forget $trans_boxes.tr
    } else {
			ShowTransWindow on
      pack $trans_boxes.tr -before $trans_boxes.meter -side top
    }
    
}
#E
#---------------------------------------------------------------
proc TrimPath { } {
#A

    global pattern
    global patternwithpath
    global trimpath

    # search for "m" and ignore everything before that

    set filelist [file split $pattern] 
    # puts $filelist  ;# --> {/ home werner prg jongl m 3}  

    if { $trimpath } {
        set found 0
        set filename {}
        foreach i $filelist {
            if {$found == 0} {
                if {$i=="m"} {    
                    set found 1
                    set filename [file join $filename $i]
                } 
            } else {
                set filename [file join $filename $i]
            }
        }
        set pattern $filename
    } else {
        set pattern $patternwithpath
    }
}

#E
#---------------------------------------------------------------
proc validSS { ss } {
#A returns siteswap throws in a list if $ss is valid, else -1

	global num_ss_hands

# valid siteswaps: ficken(17) bla(14) frank(19) rimpau(22) hein(18) ben(16) 
# theeg(18)  ken

# more patterns for testing (watch statement while typing)
# 97531     7p7p     6x446x    335p5p    3.5p3.5p   4.5 5.5  ax2x2xax

	set cross 0
	if { $num_ss_hands == "[LT 2838]" } {
		if { [ regexp {[x]} $ss ] == 0 } {
			# no sync throws:
			# remove chars in standard mode
			set sst [ TrimSS $ss 0 ]
		} else {
			# convert sync pattern to async pattern
			set ssl [ sync2async $ss ]
			if { $ssl == -1 } { return -1 } ; # caught error
			set cross 1
		}
	} else {
		set sst $ss
	}
	
	if { [ info exists ssl ] == 0 } {
		set ssl [ makeListFromString $sst ] ; # strip spaces
	}
	set p [ llength $ssl ] ; # set period

	if { [ Odd $p ] && $cross } { return -1 }
	
	set ssc $ssl ; # make copy for checking
	for { set i 0 } { $i < $p } { incr i } {
		# add position, then modulo period
		set t [ expr ([lrange $ssc $i $i ] + $i)% $p ]  
		set ssc [ lreplace $ssc $i $i $t]
	}
	
	# check if every number is contained exactly once:
	for { set i 0 } { $i < $p } { incr i } {
		if { [ lsearch $ssc $i ] == -1 } { return -1 }
	}
	
	return $ssl 
}
#E
#---------------------------------------------------------------
proc WhoDidIt { } {
#A   includes also the short explanation about siteswap notation

    global currentregister
    global w

    set S22J_HELP tmp/s22j_help
    
    switch $currentregister {
        "j2" {
            tk_messageBox  -icon info -message "J2 by Jack Boyce\n\njboyce7@yahoo.com\n\nSee directory j2 for documentation." -type ok 
        }
        "ss" {
            set ww .s22j
            toplevel $ww
            wm withdraw $ww
            wm title $ww s22j
            # height in lines:
						text $ww.t -height 25 
#            # use original s22j executable to produce help text:
#            exec s22j >$S22J_HELP
#            set id [open $S22J_HELP r]
#            while { ! [eof $id] } {
#                $ww.t insert end [gets $id]
#                $ww.t insert end "\n"
#            }
#            close $id
            foreach t {
							2848  "\n" 2849 2850 2851 2852 2853 2854 2855 2856 2857 
							2858 2859 "\n" 2860 2861 2862 "\n" 2863 2864 2865 2866 2867
							2868 2869
            } {
              if { $t > 0 } {  
								$ww.t insert end "[LT $t]\n"
							} else {
								$ww.t insert end "$t"
							}
            }
            pack $ww.t 
            button $ww.b -text OK -command "destroy $ww" -default active
            pack $ww.b 
            update idletasks
            #         center current window on screen:
            #        (siehe S. 299 Ousterhout)
            set xpos [expr [winfo screenwidth $w]/2 - [winfo reqwidth $ww]/2 \
                          - [winfo vrootx [winfo parent $w]]]
            set ypos [expr [winfo screenheight $w]/2 - [winfo reqheight $ww]/2 \
                          - [winfo vrooty [winfo parent $w]]]
            wm geom $ww +$xpos+$ypos
						bind $ww  <Return> "destroy $ww"
						bind $ww  <Escape> "destroy $ww"
            wm deiconify $ww
        }
        default {
            tk_messageBox  -icon info -message "Werner Riebesel\n\
werner@jongl.de\n\
http://www.jongl.de\n\n\
& Ludwig Klam, Martin Hoffmann, Johannes Weissl\n\n\
[LT 2769]\n\
    C, Assembler, OpenGL, VRML, HTML, lex, yacc, Tcl/Tk, PNG-library.\n\n\
    [LT 2789]\n\n\
    See ./doc/spec.html for details.\n\n\
		(c) 1992-2008" -title [LT 2746] -type ok 
        }
     }
}

#E
#---------------------------------------------------------------
proc Write1Shirt { fpout shirtname frontbitmap backbitmap } {
#A
    puts $fpout $shirtname
    if { $frontbitmap > 0 } { 
        puts $fpout "  $frontbitmap" 
        set frontbitmap 0
    }
    if { $backbitmap > 0} {
        puts $fpout "  $backbitmap"
        set backbitmap 0
    }
    # this writes a newline:
    puts $fpout ""
}
#E
#----------------------------------------
proc WriteJonglPrefs { jupa ds4f } {
#A

#A globals

    global act1 act2 act3 act4
    global animscale 
    global animbitrate
    global animtype
    global bgrtex
		global bostonmess_phase
    global clipping
    global currentregister
    global delsinglepics
		#    global detail 
		global fart_index_in fart_index_out
		global font
    global fps
    global fq_bounce
    global fq_filter
    global fq_jug
    global fq_max_obj
    global fq_min_obj
    global fq_mplex
    global fq_sort
    global fre_bounce
    global fre_empty_hand
    global fre_jug
    global fre_maxMplex
    global fre_mplex
    global fre_numobj
    global fre_period
    global fre_radius
    global freq 
    global groundname
#    global ground_name  ;# array
#    global ground_file  ;# array
    global hardcopydir 
    global height 
    global hold2 
    global internalInt
    global internalText
    global j2_11
    global j2_active_index
    global j2_decomp
		global j2_gen_pat_but
    global j2_i
    global j2_last_max
    global j2_last_numobj
    global j2_last_period
    global j2_options_window
    global j2_passing
    global j2_state
    global j2_x
    global j2_xp
    global jongldir
    global juggler_detail
    global jugglingpattern
    global jrc
    global local 
    global maxfps
    global mousespeed
    global nofork
		global num_obj
    global object_type
    global pattern
    global patterndir
    global patternfilter
    global patternwithpath
    global povray83
    global povraydir 
    global prefsfile 
    global randomcolor
		global scatter
		global shade ;# array
    global shading
    global show_bostonmess_call show_fart_call show_s22j_call show_j2_call show_sstart_call
    global siteswap
    global siteswapdir
    global ss_hands
#    global ss_left
    global ss_options_num
    global ss_siteswap
#    global ss_right
    global state ;# array
    global sync 
    global textures 
    global throw_trans
    global timestretch
		#    global tempdir
		global trans_changed_by_fart
    global trans_ground
		global trans_in
		global trans_len_in   trans_len_out   trans_height_in   trans_height_out
		global trans_much_options
		global trans_out
    global show_trans_window
    global trans_siteswap
    global trimpath
    global vrmlobjects 
    global width

    global COMMERCIAL
    global DEBUG

#E
#A write header
    set jugglingpattern $jupa
    cd $jongldir

    set id [open $prefsfile w]

    puts $id "JonglPrefsV9\n"
    puts $id "!  DO NOT CHANGE THIS FILE BY HAND\n"
    puts $id "!  Version 14.7\n"
#E
#A patterns and siteswap
    puts $id "!  Register Patterns\n"  ;# --------------------------------
    puts $id [format "bostonmess_phase = %d" $bostonmess_phase]
    puts $id [format "dontsearch4file = %d" $ds4f ]
    puts $id [format "file = %s" $patternwithpath]
    puts $id [format "_filter = %s" $patternfilter]
    puts $id [format "hold2 = %d" $hold2]
# jugglingpattern is the pattern which is currently used.
    puts $id [format "jugglingpattern = %s" $jugglingpattern]
    puts $id [format "multihandsiteswap = %d" [ MHSS_num_hands ] ]
		if { $num_obj > 0 } { ; # num_obj only for invocation of bostonmess.exe
			puts $id [format "num_obj = %d" $num_obj]
		} else {
			puts $id [format "num_obj = %d" $j2_last_numobj]
		}
		puts $id [format "object_type = %d" $object_type]
    puts $id [format "patterndir = %s" $patterndir]
    puts $id [format "_show_trans_window = %s" [ expr $show_trans_window > 0 ? 1 : 0 ] ]
    puts $id [format "siteswap = %s" $siteswap]
    puts $id [format "ss_hands = %s" $ss_hands]
    puts $id [format "ss_options = %d" $ss_options_num]
    puts $id [format "ss_siteswap = %s" $ss_siteswap]
    puts $id [format "sync = %d" $sync]
    puts $id [format "throw_trans = %d" $throw_trans]
    puts $id [format "trans_ground_state = %d" $trans_ground]
    puts $id [format "_trans_height_in = %s" $trans_height_in]
		puts $id [format "_trans_height_out = %s" $trans_height_out]
    puts $id [format "trans_in = %s" $trans_in]
    puts $id [format "_trans_len_in = %s" $trans_len_in]
    puts $id [format "_trans_len_out = %s" $trans_len_out]
    puts $id [format "_trans_much_options = %d" $trans_much_options]		
		puts $id [format "trans_out = %s" $trans_out]
    puts $id [format "trans_siteswap = %d" $trans_siteswap]
    puts $id [format "_trimpath = %d" $trimpath]
#E
#A J2
    puts $id "\n!  Register J2\n"  ;# --------------------------------
    puts $id [format "_j2_11 = %d" $j2_11]
    puts $id [format "j2_active_index = %d" $j2_active_index]
#puts -nonewline "write: "
#puts $j2_active_index
    puts $id [format "_j2_decomp = %d" $j2_decomp]
    puts $id [format "_j2_gen_pat_but = %d" $j2_gen_pat_but]
    if { [ string length $j2_i] == 0 } { set j2_i "-" }
    puts $id [format "_j2_i = %s" $j2_i]
    # write _last_ values to jongl.prefs -> always have the right pattern file
    puts $id [format "_j2_max = %d" $j2_last_max]
    puts $id [format "_j2_numobj = %d" $j2_last_numobj]
    puts $id [format "_j2_options_window = %d" $j2_options_window]
    puts $id [format "j2_passing = %d" $j2_passing]
#    puts $id [format "_j2_pattern = %d" $j2_pattern]
    puts $id [format "_j2_period = %d" $j2_last_period]
    foreach index [array names state] {   ;# get indices
        if {$state($index) == $j2_state} {
            puts $id [format "_j2_state = %d" $index]
            break
        }
    }
    if { [ string length $j2_x] == 0 } { set j2_x "-" }
    puts $id [format "_j2_x = %s" $j2_x]
    if { [ string length $j2_xp] == 0 } { set j2_xp "-" }
    puts $id [format "_j2_xp = %s" $j2_xp]
#E
#A freestyle
    puts $id "\n!  Register Freestyle\n"  ;# --------------------------------
    puts $id [format "_fre_bounce = %d" $fre_bounce]
    puts $id [format "_fre_empty_hand = %d" $fre_empty_hand]
    puts $id [format "_fre_jug = %d" $fre_jug]
    puts $id [format "_fre_maxMplex = %d" $fre_maxMplex]
    puts $id [format "_fre_mplex = %d" $fre_mplex]
    puts $id [format "_fre_numobj = %d" $fre_numobj]
    puts $id [format "_fre_period = %d" $fre_period]
    puts $id [format "fre_radius = %f" $fre_radius]

#E
#A settings
    puts $id "\n!  Register Settings\n"  ;# --------------------------------
    if { $clipping == [LT 2729] } {
        set clipping "fast"
    } else {
        set clipping "nice"
    }
    puts $id [format "clipping = %s" $clipping]
		#    puts $id [format "detail = %d" $detail]

		puts $id [format "groundname = %s" $groundname]
    puts $id [format "local = %s" $local]
    puts $id [format "font = %d" $font]
    puts $id [format "fps = %d" $fps]
    puts $id [format "height = %d" $height]
    puts $id [format "jrc = %d" $jrc]
    if { $juggler_detail == [LT 2729] } {
        set juggler_detail "fast"
    } else {
        set juggler_detail "nice"
    }
    puts $id [format "juggler_detail = %s" $juggler_detail]
    puts $id [format "mousespeed = %f" $mousespeed]
    puts $id [format "randomcolor = %d" $randomcolor]
    puts $id [format "scatter = %d" $scatter]
 
    foreach index [array names shade] {   ;# get indices
        if {$shade($index) == $shading} {
            puts $id [format "shading = %d" $index]
            break
        }
    }

    puts $id [format "textures = %d" $textures]
    puts $id [format "timestretch = %f" $timestretch]
    puts $id [format "vrmlobjects = 1"]
    puts $id [format "width = %d" $width]
#E
#A export
    puts $id "\n!  Register Export\n"  ;# --------------------------------
    puts $id [format "ab = %d" $animbitrate]
    puts $id [format "animtype = %s"  $animtype]
    puts $id [format "as = %d"  $animscale]
    puts $id [format "delsinglepics = %d"  $delsinglepics]
    puts $id [format "freq = %d" $freq]
    puts $id [format "hardcopy = %s" $hardcopydir]
    if { $povray83 == 0} {
        puts $id [format "povraydir = %s" $povraydir]
    } else {
        puts $id [format "povraydir = %s 8.3" $povraydir]
    }
#    puts $id [format "temp = %s" $tempdir]
    puts $id [format "siteswapdir = %s" $siteswapdir]
#E
#A internal
    puts $id "\n!  Internal\n"  ;# --------------------------------
		# fq stands for file requester
    puts $id [format "currentregister = %s" $currentregister]
    puts $id [format "_fart_index_in = %d" $fart_index_in]
    puts $id [format "_fart_index_out = %d" $fart_index_out]
#    puts $id [format "_fq_bounce = %d" $fq_bounce]
    puts $id [format "_fq_filter = %d" $fq_filter]
#    puts $id [format "_fq_jug = %d" $fq_jug]
    puts $id [format "_fq_max_obj = %d" $fq_max_obj]
    puts $id [format "_fq_min_obj = %d" $fq_min_obj]
#    puts $id [format "_fq_mplex = %d" $fq_mplex]
    if { $fq_sort == [LT 2772] } {
        puts $id [format "fq_sort = alpha"]
    } else {
        puts $id [format "fq_sort = num"]
    }
    puts $id [format "_trans_changed_by_fart = %d" $trans_changed_by_fart]

#E
#A develop
        if { $COMMERCIAL == -1 } {
            set act1 0
            set act2 0
            set act3 0
            set act4 0
            set bgrtex off
            set internalInt 17
            set internalText off
            set maxfps 85
            set nofork 0
        }

        if { [string length $bgrtex] == 0 } {
            set bgrtex "none"
        }
        if { [string length $internalText] == 0 } {
            set internalText "none"
        }
        
        puts $id "\n!  Register Develop\n"  ;# --------------------------------
        if { ! $act1 } { puts -nonewline $id "!" }
        puts $id [format "backgroundtexture = %s" $bgrtex]
        if { ! $act2 } { puts -nonewline $id "!" }
        puts $id [format "internalInt = %d" $internalInt]
        if { ! $act3 } { puts -nonewline $id "!" }
        puts $id [format "InternalText = %s" $internalText]
        if { ! $act4 } { puts -nonewline $id "!" }
        puts $id [format "maxfps = %d" $maxfps]

        puts $id [format "nofork = %d" $nofork]
        puts $id [format "show_bostonmess_call = %d" $show_bostonmess_call]
        puts $id [format "_show_fart_call = %d" $show_fart_call]
        puts $id [format "_show_j2_call = %d" $show_j2_call]
        puts $id [format "show_s22j_call = %d" $show_s22j_call]
#        puts $id [format "_show_sstart_call = %d" $show_sstart_call]
        
#E

    puts $id "\n! JonglPrefsV9 complete\n"
    close $id

    # after successful writing
    # make backup of current jongl.prefsV9:
    file copy -force $prefsfile $prefsfile.backup
    
    if { $DEBUG & 1 } { putsDebug "Wrote jongl.prefs" }
}

#E
#---------------------------------------------------------------
proc write_binary { val } {
#A return input as binary    
	set bin " "
 
	while { $val >0 } {
		if { [ Odd $val ] } {
		        # odd: bit = 1
		        set bin [format "1%s" $bin]
		} else {
		        # even: bit = 0
		        set bin [format "0%s" $bin]
		}
		set val [expr int($val/2)]
	}
	return $bin
}
#E
#---------------------------------------------------------------
#---------------------------------------------------------------
#---------------------------------------------------------------
#- end of function definitions - start of program --------------
#---------------------------------------------------------------
#---------------------------------------------------------------
#---------------------------------------------------------------
#A     main() 

if { $DEBUG & 1 } { putsDebug "Start" }

wm withdraw .

if { $COMMERCIAL == 0 } {
    # add "dev" to buttonlist:
    set buttonlist [ linsert $framelist end dev ]
} else {
    set buttonlist $framelist
}

set jongldir [pwd]

# Read parameter passing file:
# 1 parameter per line:
set id [open $TCL_PASSING_FILE r]
# parameter 1: window title:
# ( if $j_title contains "NO_TRANS" then don't compute transitions)
gets $id j_title
# parameter 2: optional siteswap pattern
# (if $opt_siteswap == "NO" then don't start GUI, only rewrite jongl.prefs)
gets $id opt_siteswap
# parameter 3: optional pattern
gets $id opt_patternwithpath
# parameter 4: j2_active_index
gets $id temp_j2_active_index
#puts -nonewline "read "
#puts $j2_active_index
# parameter 5: flag: how often has a new pattern been selected
gets $id restarts
close $id


if { $DO_NOT_READ_JONGL_PREFS == 0 } { 
    if { $DEBUG & 1 } { putsDebug "before ReadJonglPrefs" }
    ReadJonglPrefs
}

if { [ string first "NO_TRANS" $j_title ] == -1 } {
	if {  ! [ file exists $SETUP_FILE ] } {
		Setup 
	} else { 
		set vid [open $SETUP_FILE r]
		gets $vid j_version
		close $vid
		if { [ string compare $j_title $j_version ] } {
			# SETUP_FILE contains different version than current program:
			Setup
		}
	}
}


#A write parameters to jongl.prefs:
if { $DIRECT_CALL == 0 } {
    if { $opt_siteswap != "NO" } {
        # User has typed pattern as parameter on command line
				set j2_active_index $temp_j2_active_index
        if { $opt_siteswap != "" } {
            # siteswap is used as a global variable, too
						# so do not overwrite it here
						if { $currentregister == "j2" && [ string first "NO_TRANS" $j_title  ] == -1 } {
							# get trans_in and trans_out:
							set j2_pattern [ SeparateJ2throws [ J2_find_line $opt_siteswap ] ]
							set opt_siteswap [ makePatternWithTransitions \
								$j2_numobj  $trans_in $j2_pattern $trans_out ] 
#							putsDebug $opt_siteswap
							# write pattern to passing file:
							set id [open $TCL_PASSING_FILE w]
							puts $id $opt_siteswap
							close $id
						}
            WriteJonglPrefs $opt_siteswap 1
        } else {
						# opt_siteswap == ""
            set patternwithpath $opt_patternwithpath
            WriteJonglPrefs $patternwithpath 0
        }
        # and stop
        destroy .
				# without "return 0" Tcl_EvalFile would not return TCL_OK
				return 0
    }
}
#E

# for use with VRML/old objects selection
if { $restarts > 0 } {
    set this_state disabled
} else {
    set this_state normal
}

set w .jongl
toplevel $w
wm withdraw .jongl
#wm transient $w ""
wm title .jongl $j_title
wm protocol .jongl WM_DELETE_WINDOW { Quit }
bind .jongl <Return> Jongl
bind .jongl <Escape> Quit

$w config -bg gray

# read dir containing panorama/background data
selectPano init
# jongl.prefs has been read, so we can search for the index
selectPano check
				
if { $DEBUG & 1 } { putsDebug "before creating common buttons" }

#E
#----------------------------------------
#A     Create common buttons: JONGL - cancel ... ?

set f [frame $w.common]

  button $f.ok_file -text "  JONGL  " -bg $darkblue -activebackground $darkblue -fg white -activeforeground white -command Jongl -state active
  pack $f.ok_file -side left -padx 2 -pady 2

  button $f.back -text " [LT 71] "  -command { destroy . }
  pack $f.back -side left -padx 2 -pady 2

  button $f.quit -text " [LT 72] "  -command Quit 
  pack $f.quit -side left -padx 2 -pady 2

  button $f.help -text "    ?    "  -command WhoDidIt
  pack $f.help -side left -padx 2 -pady 2

pack $f -side bottom -padx 2 -pady 2 


###########  R E G I S T E R    B U T T O N S  ###################

set f [frame $w.register]

  if { [ Check4Mac ] } {
  	button $f.pat -text [ LT 2710 ]  -command { ShowFrame pat true } -default active
  } else {
  	button $f.pat -text [ LT 2710 ]  -command { ShowFrame pat true } -relief sunken 
  }
#    -bg $darkblue -activebackground $darkblue -fg white -activeforeground white
  pack $f.pat -side left -padx 2 -pady 2 -fill x

  button $f.ss -text "siteswap"  -command { ShowFrame ss true}
  pack $f.ss -side left -padx 2 -pady 2 -fill x

  button $f.j2 -text "j2"  -command { ShowFrame j2 true}
  pack $f.j2 -side left -padx 2 -pady 2 -fill x

  button $f.fre -text "freestyle"  -command { ShowFrame fre true}
  pack $f.fre -side left -padx 2 -pady 2 -fill x

  button $f.set -text [LT 2711]  -command { ShowFrame set true }
  pack $f.set -side left -padx 2 -pady 2 -fill x

  button $f.exp -text [LT 2712]  -command { ShowFrame exp true }
  pack $f.exp -side left -padx 2 -pady 2 -fill x

  if { $COMMERCIAL == 0 } {
    button $f.dev -text "Develop"  -command { ShowFrame dev true }
    pack $f.dev -side left -padx 2 -pady 2 -fill x
  }

pack $f -padx 2 -pady 2 -anchor w 

if { $DEBUG & 1 } { putsDebug "after common buttons" }

#E
#----------------------------------------
#A     object buttons

  set obb [frame $w.obb ]
     tk_optionMenu $obb.obj_name object_name "[LT 2786]"  \
           "[LT 2779]"  "[LT 2780]" "[LT 2781]" "[LT 2782]" \
           "[LT 2784]" "[LT 2785]"
    trace variable object_name w TraceObject
    pack $obb.obj_name -padx 3 -pady 3 -side right -anchor e

    pack [checkbutton $obb.randomcolor -text [LT 2778]]  \
    -fill x -expand true -padx 3 -pady 3 -side left -anchor w

# pack is in ShowFrame

#E
#----------------------------------------
#A     buttons for both "siteswap" and "j2"
	set mhss [ frame $w.mhss ]
	
		set rb [frame $mhss.f5 ]
        set f_both [frame $rb.f3 ]
				# buttons for "throw transitions", "hold 2" and "sync"
    		pack [checkbutton $f_both.throw_trans -text [LT 2839]  ] -anchor w -padx 10 -pady 1
				trace variable throw_trans w TraceThrowTrans
    		pack [checkbutton $f_both.hold2 -text [LT 2719]  ] -anchor w -padx 10 -pady 1
				pack [checkbutton $f_both.sync -text [LT 2720]  ] -anchor w -padx 10 -pady 1
				trace variable sync w TraceSS_options
        pack $f_both -side left

		# option menu for radius between jugglers (same variable as in freestyle tab):
 			set rr [frame $rb.r4]
## fart: von HIER
			           set tr [frame $rr.tr]
                   set  tr1 [frame $tr.tr1]
                     tk_optionMenu $tr1.ground trans_ground 1 2 3 4 5 6 7 8 9 10
                     pack $tr1.ground -side left -padx 3 -pady 1
                     pack [label $tr1.gs -text [LT 2840] ] -anchor e -side left -fill both -expand true
                   pack $tr1 -side top -anchor w
                   set  tr2 [frame $tr.tr2]
                     tk_optionMenu $tr2.siteswap trans_siteswap 1 2 3 4 5 6 7 8 9 10
                     pack $tr2.siteswap -side left -padx 3 -pady 1
                     pack [label $tr2.ss -text [LT 2841] ] -anchor e -side left -fill both -expand true
                   pack $tr2 -side top -anchor e
								## fart: bis HIER ausblenden
  #                pack $tr -anchor e ; # depends on checkbutton $rff.throw_trans

 				pack [label $rr.meter -text " m   " ] -side right
 				source "tcl/radius.tcl"
 				pack $rr.radius -side right -pady 1
 				pack [ label $rr.l_radius -text "[LT 2625] "  ] -anchor e -side right
 			pack $rr -anchor e ; # -expand true -fill x

      # standard throws / throws per hand / ...
			tk_optionMenu $rb.ss_options ss_options [LT 2806] "boston mess" [LT 2807] [LT 2808]
      pack $rb.ss_options -side right -padx 3 -pady 1
      trace variable ss_options w TraceSS_options

     pack $rb -expand true -fill both

     # here the frame "hands" will be inserted.
	
		# Standard, Solo, 4-handed, 6-handed:
		tk_optionMenu $mhss.num_ss_hds num_ss_hands \
    "[LT 2838]" "[LT 2831]" "[LT 2832]" "[LT 2833]" ; # "[LT 2834]" "[LT 2835]"
		trace variable num_ss_hands w TraceMHSS
		pack $mhss.num_ss_hds -anchor e -padx 3 -pady 1 -side right
		
		set avoid_text " " ; # is set in ShowFrame
    pack [label $mhss.label -text $avoid_text ] -padx 10 -side right -anchor e

	# pack is in ShowFrame

#E
#----------------------------------------
#A     P A T T E R N S

set r [frame $w.pat]

#button $r.logo -bitmap @jongl_logo_bw_h.xbm -relief flat -command WhoDidIt
  set rf [frame $r.f0 -bg $darkblue]
    catch {image delete logo}
    image create photo logo -file "tcl/jongl_logo_8.gif"
    label $rf.logo -image logo  -bd 0
    pack $rf.logo
  pack $rf -fill both -expand yes
  
  set rf [frame $r.f1 -bg $darkblue]
    set rff [frame $rf.f0 -bg $darkblue]
      pack [label $rff.label -text "\n[LT 2713]" -bg $darkblue -fg white]  \
							-padx 10 -side left -anchor sw
      pack [checkbutton $rff.trimpath -text [ LT 2715] -bg $darkblue \
							-activebackground $darkblue -activeforeground red -fg black \
							-command TrimPath] -side right -padx 10 -anchor se
    pack $rff -expand true -fill x
    pack [entry $rf.entry -textvariable pattern ] -fill x -expand true -padx 10 -pady 10
    bind $rf.entry <Return> Jongl
    set rff [frame $rf.f1 -bg $darkblue]
      pack [button $rff.fopen -text [LT 2714] -command OpenFile] \
             -side left -padx 10 -pady 20
    pack $rff 
  pack $rf -fill both -expand yes

if { $DEBUG & 1 } { putsDebug "after patterns" }

#E
#----------------------------------------
#A     S I T E S W A P

set r [frame $w.ss]

  set rf [frame $r.f4 -bg $lightblue ]
      pack [label $rf.label -text "\n[LT 2718]" -bg $lightblue] -anchor w -padx 10 
      pack [entry $rf.entry -textvariable siteswap]  -fill x -expand true -padx 10 
      bind $rf.entry <Enter> "focus $rf.entry"
      bind $rf.entry <Return>  Jongl 
      trace variable siteswap w TraceSS_options
      set st [frame $rf.st -bg $lightblue ]
      # these 2 text fields are filled out in TraceSS_options
      pack [label $st.transitions -text " " -bg $lightblue] -anchor w -side left -fill x -expand true
	    pack [label $st.status -text " " -bg $lightblue] -anchor e -side right -fill x -expand true
      pack $st -padx 10 -pady 10 -expand true -fill x

  pack $rf -fill both -expand yes

# pack $r  is in ShowFrame

if { $DEBUG & 1 } { putsDebug "after siteswap" }

#E
#----------------------------------------
#A     J2

set r [frame $w.j2]

  label $r.l -text "[LT 2753]\n[LT 2754]"
  pack $r.l

	#A  3 sliders + text
	
  set r0 [frame $r.r0 -relief groove -bd 2]
    set rr [frame $r0.num]
      label $rr.l_num -text [LT 2749]
#      tk_optionMenu $rr.num j2_numobj \
#    1 2 3 4 5 6 7 8 9 10 11 
      pack [scale $rr.num -variable j2_numobj -orient horizontal \
                -from 1 -to 36 -showvalue true ] \
                -fill x -expand true -side left
			trace variable j2_numobj w TraceJ2
      pack $rr.l_num -side top -anchor w  
      pack $rr.num -side bottom 
    pack $rr -side left -expand 1 -fill both
  
    set rr [frame $r0.max]
      label $rr.l_max -text [LT 2750]
#      tk_optionMenu $rr.max j2_max  \
#    1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
      pack $rr.l_max  
      pack [scale $rr.max -variable j2_max -orient horizontal \
                -from 1 -to 36 -showvalue true ] \
                -fill x -expand true -side left
			trace variable j2_max w TraceJ2
  		pack $rr -side left -expand 1 -fill both
  
    set rr [frame $r0.period]
      label $rr.l_period -text [LT 2751]
#      tk_optionMenu $rr.period j2_period \
#    1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
      pack [scale $rr.period -variable j2_period -orient horizontal \
                -from 1 -to 20 -showvalue true ] \
                -fill x -expand true -side left
			trace variable j2_period w TraceJ2
      pack $rr.l_period -side top -anchor e
			pack $rr.period -side bottom  
    pack $rr -side left -expand 1 -fill both 
  pack $r0 -padx 4 -pady 4 -expand 1 -fill both

	#E
	
  # buttons
  set r0 [frame $r.b]
    button $r0.gen -text "[LT 2847] --> [LT 2900]" -bg $lightblue -command J2_start \
    -activebackground $lightblue -activeforeground red
    pack $r0.gen -side left -padx 2 -pady 2 -ipadx 10
    button $r0.j2_options -text "[LT 2801]" -command { J2_options_window toggle }
    pack $r0.j2_options -side right -padx 2 -pady 2
  pack $r0 -padx 4 -pady 4 

  set j2f [frame $r.lb]
  # siehe Tcl/Tk S. 186
    listbox $j2f.lb -yscrollcommand "$j2f.sb set" -width 0
    pack $j2f.lb -side left -expand true -fill both
    bind $j2f.lb <Double-Button-1> Jongl
    scrollbar $j2f.sb -command "$j2f.lb yview"
    pack $j2f.sb -side right -expand true -fill y
  pack $j2f -expand true -fill both

  label $r.lcp -text "0 [LT 2710]"
  pack $r.lcp 

if { $DEBUG & 1 } { putsDebug "after J2" }

#E
#----------------------------------------
#A     F R E E S T Y L E

# Multiplex ausgeblendet! (MP)

set r [frame $w.fre]

  label $r.l -text "[LT 2770]"
  pack $r.l

#A main 3 optionMenus
  set r0 [frame $r.r0 -relief groove -bd 2 -bg $lightblue]

    set rr [frame $r0.max -bg $lightblue]
      label $rr.l_max -text [LT 2766] -bg $lightblue
      tk_optionMenu $rr.max fre_jug 1 2 3 4 5 6 7 8 9 10 
      pack $rr.l_max $rr.max 
      trace variable fre_jug w TraceFreestyle
    pack $rr -side left -expand 1 -fill x -pady 7
  
    set rr [frame $r0.num -bg $lightblue]
      label $rr.l_num -text [LT 2749] -bg $lightblue
      tk_optionMenu $rr.num fre_numobj 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
      pack $rr.l_num $rr.num 
      trace variable fre_numobj w TraceFreestyle
    pack $rr -side left -expand 1 -fill x -pady 7
  
    set rr [frame $r0.period -bg $lightblue]
      label $rr.l_period -text [LT 2751] -bg $lightblue
      tk_optionMenu $rr.period fre_period 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150
      pack $rr.l_period $rr.period 
      trace variable fre_period w TraceFreestyle
    pack $rr -side left -expand 1 -fill x 

  pack $r0 -padx 4 -pady 4 -expand 1 -fill x -pady 7
#E
  set r1 [frame $r.r1]
#A frame for texts:
    set rr [ frame $r1.texts]
		# prob. for empty hand:
      pack [label $rr.lbl1 -text "[LT 2768] "] -anchor e -fill y -expand true
if { $COMMERCIAL == 0 }   {
		# prob. for bouncing:
      pack [label $rr.lbl2 -text "[LT 2767] "] -anchor e  -fill y -expand true
}
				# probability for multiplex:
#MP      pack [label $rr.lbl3 -text "[LT 2798] "] -anchor e -fill y -expand true

#MP      pack [ label $rr.l_maxMplex -text "[LT 2799]" ] -anchor e -fill y -expand true
      pack [ label $rr.l_radius -text "[LT 2625]" ] -anchor e -fill y -expand true
    pack $rr -fill both -expand true -side left
#E
#A frame for sliders and buttons:
    set rrr [frame $r1.sliders]
  
      set rr [frame $rrr.r1]
        pack [label $rr.val1 -textvariable fre_empty_hand] -side left
        pack [label $rr.percent -text "%"] -side left
        pack [scale $rr.scl1 -variable fre_empty_hand -orient horizontal \
                  -from 0 -to 60 -showvalue false ] \
                  -fill x -expand true -side left
      pack $rr -anchor w -expand true -fill x 
  
      if { $COMMERCIAL == 0 }   { 
        set rr [frame $rrr.r2]
          pack [label $rr.val2 -textvariable fre_bounce] -side left
          pack [label $rr.percent -text "%"] -side left
          pack [scale $rr.scl2 -variable fre_bounce -orient horizontal -from 0 -to 100 -showvalue false \
                   ]  -fill x -expand true -side left
        pack $rr -anchor w -expand true -fill x
      }
  
      set rr [frame $rrr.r3]
        pack [label $rr.val3 -textvariable fre_mplex] -side left
        pack [label $rr.percent -text "%"] -side left
        pack [scale $rr.scl3 -variable fre_mplex -orient horizontal -from 0 -to 100 -showvalue false \
               ]  -fill x -expand true -side left
        trace variable fre_mplex w TraceFreestyle
#MP      pack $rr -anchor w -expand true -fill x
  
      tk_optionMenu $rrr.maxMplex fre_maxMplex 2 3 4 
#MP      pack $rrr.maxMplex -anchor w
  
      set rr [frame $rrr.r4]
			  source "tcl/radius.tcl"
        TraceFreestyle fre_jug ignore ignore
        pack $rr.radius -side left
        pack [label $rr.meter -text "m"] -side left
      pack $rr -anchor w -expand true -fill x
  
    pack $rrr -fill both -expand true -side left
#E
  pack $r1 -fill both -expand true 
#A frame for checkbutton(s):
  set rr [frame $r.cb]
pack [checkbutton $rr.sync -text "[LT 2720]"  ] ;#-anchor w
  pack $rr -fill both -expand true -side bottom 
#E end of frames

if { $DEBUG & 1 } { putsDebug "after freestyle" }

#E
#----------------------------------------
#A     S E T T I N G S 

set debug_border 0

set r [frame $w.set]

  frame $r.rb 
  pack $r.rb  -fill x -expand true -padx 7 -pady 7
  
  # VRML graphic:
  frame $r.gr -relief groove -bd 2
#    tk_optionMenu $r.gr.quick quickvrml $quicktext(0) $quicktext(1) $quicktext(2) $quicktext(3)
#    pack $r.gr.quick  -side left -expand true -fill y

   # top frame
    set ft [ frame $r.gr.top  -relief groove -bd $debug_border]

    # left frame: label texts
		set ff [frame $ft.lbl  -relief groove -bd $debug_border]
      pack [label $ff.jug -text [LT 2790] ]  -anchor w -expand true -fill y
#      pack [label $ff.grn -text [LT 2791] ]  -anchor w -expand true -fill y
      pack [label $ff.clip -text [LT 2725] ]  -anchor w -expand true -fill y
      pack [label $ff.shading -text [LT 2727] ]  -anchor w -expand true -fill y
    pack $ff -side left -padx 2 -pady 2 -expand true -fill y

		# right frame: option menus
    set ff [frame $ft.om  -relief groove -bd $debug_border]
      tk_optionMenu $ff.jug juggler_detail [LT 2729] [LT 2730]
      pack $ff.jug  -anchor w -expand true -fill y

      # old ground selection (Karoboden)
			#tk_optionMenu $ff.grn ground "dummy"
      #pack $ff.grn  -anchor w -expand true -fill y

      tk_optionMenu $ff.clip clipping [LT 2729] [LT 2730]
      pack $ff.clip  -anchor w -expand true -fill y

      tk_optionMenu $ff.shading \
        shading $shade(0) $shade(1) $shade(2) $shade(3) $shade(4) $shade(5) 
      pack $ff.shading  -anchor w -expand true -fill y
    pack $ff -side right -expand true -fill both -anchor w
		
		pack $ft -side top -anchor w -expand true -fill both
		
		#right frame: ground / textures
    set ff [frame $r.gr.gt]
      pack [checkbutton $ff.textures -text [LT 2733] ] -side left -fill x -expand true
			trace variable textures w TraceTextures

			# frame for ground selection
			set fg [ frame $ff.gr ]
			  set ppad 5
				set fgl [ frame $fg.left ]
			    pack [ button $fgl.left -text "  <  " -command { selectPano prev } ] \
					-anchor e -padx $ppad -pady $ppad 
					pack [ label $fgl.grn -text [LT 2791] ]  -anchor s -expand true -fill y -pady 2
			  pack $fgl -side left -anchor s

				# display current pano thumbnail
				selectPano display
				label $fg.pano -image pano  -bd 1 -relief groove
				pack $fg.pano -side left  -padx $ppad -pady $ppad

			  pack [ button $fg.right -text "  >  " -command { selectPano next } ] \
				-side left  -padx $ppad -pady $ppad 
			pack $fg -side left -expand true

    pack $ff -side bottom -expand true -fill both -anchor w

  pack $r.gr  -fill x -expand true -padx 7

  # 3d window
  set rf [frame $r.f1 -relief groove -bd 2]  
    pack [label $rf.width_label -text "[LT 2723] "  ] -side left -padx 7 -pady 7
    pack [entry $rf.width_entry -width 4 -textvariable width ] -side left -fill x \
            -expand true -padx 7 -pady 7
    bind $rf.width_entry <Enter> "focus $rf.width_entry"
    
    pack [label $rf.height_label -text "    [LT 2724] "  ] -side left 
    pack [entry $rf.height_entry -width 4 -textvariable height] -side left -fill x -expand true -padx 7
    bind $rf.height_entry <Enter> "focus $rf.height_entry"
  pack $rf  -expand true -fill x -padx 7 -pady 7

  set fff [frame $r.f0]
    set ff [frame $fff.f1]
      pack [label $ff.lang -text "[LT 2726]" ]  -anchor w -expand true -fill y
      pack [label $ff.font -text "[LT 2728]" ]  -anchor w -expand true -fill y
    pack $ff -side left -padx 2 -pady 2 -expand true -fill y
    
    set ff [frame $fff.f2]
      # Don't use special characters here, because these are the file names!
			# see same menu at approx. line 3426
			tk_optionMenu $ff.lang local "deutsch" "english" "francais" "espanol" "catala"
      pack $ff.lang  -anchor w -expand true -fill y
      trace variable local w TraceLocal
    
      tk_optionMenu $ff.font font "13" "15"
      pack $ff.font  -anchor w -expand true -fill y 
    pack $ff -side left -expand true -fill both -anchor w

    set ff [frame $fff.f3]
      button $ff.newshirts -text "[LT 2797]" -command IncludeNewShirts
      pack $ff.newshirts  -side right
    pack $ff -side left -expand true -fill both -anchor e

  pack $fff  -expand true -fill both -anchor w -padx 7 -pady 7
  
  #### sliders:
  set fr [frame $r.mousespeed]
    pack [label $fr.lbl -text "[LT 2777] "] -side left
    pack [label $fr.val -textvariable mousespeed -width 4] -side left
    pack [scale $fr.scl -variable mousespeed -orient horizontal -from 0.1 -to 2.5 -showvalue false \
              -resolution 0.02]  -fill x -expand true -side left
    pack [button $fr.reset -text Reset -command { set mousespeed 1 } ] -side left
  pack $fr  -fill x -expand true -padx 2 -pady 2 

#  frame $r.detail
#    pack [label $r.detail.lbl -text "[LT 2731]  "] -side left
#    pack [label $r.detail.val -textvariable detail -width 4] -side left
#    pack [scale $r.detail.scl -variable detail -orient horizontal -from -3 -to 5 -showvalue false \
             ]  -fill x -expand true -side left
#    pack [button $r.detail.reset -text Reset -command { set detail 0 } ] -side left
#  pack $r.detail  -fill x -expand true -padx 2 -pady 2 
  
  set fr [frame $r.timestretch]
    pack [label $fr.lbl -text "[LT 2732] "] -side left
    pack [label $fr.val -textvariable timestretch -width 4] -side left
    pack [scale $fr.scl -variable timestretch -orient horizontal -from 0.5 -to 2.5 -showvalue false \
              -resolution 0.02]  -fill x -expand true -side left
    pack [button $fr.reset -text Reset -command { set timestretch 1 } ] -side left
  pack $fr  -fill x -expand true -padx 2 -pady 2 

  # checkbuttons
  frame $r.cb
##    pack [checkbutton $r.cb.jrc -text [LT 2734] -state $this_state] -side left -fill x -expand true
#    pack [checkbutton $r.cb.jrc -text [LT 2734]] -side left -fill x -expand true
    pack [checkbutton $r.cb.scatter -text [LT 2875]] -side left -fill x -expand true
    pack [checkbutton $r.cb.fps -text [LT 2735]] -side left -fill x -expand true
  pack $r.cb  -fill x -expand true -padx 7
  
#pack $r  -side left  -padx 2 -pady 2 -fill both -expand yes

if { $DEBUG & 1 } { putsDebug "after graphics" }

#E
#----------------------------------------
#A     E X P O R T
set r [frame $w.exp]
  set f0 [frame $r.f0]
#A left column of table:
    set f1 [frame $f0.f1]
      pack [label $f1.animfiletype_label -text [LT 2736] ] \
       -fill y -expand true -pady 5 -anchor e
      pack [label $f1.freq_label -text [LT 2737] ] \
       -fill y -expand true  -anchor e
      pack [label $f1.animscale_label -text [LT 2738]  ] \
       -fill y -expand true -anchor e
      pack [label $f1.animbitrate_label -text [LT 2739]  ] \
       -fill y -expand true  -anchor e
#      pack [label $f1.temp_label -text [LT 2740] ] \
       -fill y -expand true  -anchor e
      pack [label $f1.hardcopy_label -text [LT 2741]  ] \
       -fill y -expand true -anchor e
      pack [label $f1.povout_label -text [LT 2742]  ] \
       -fill y -expand true -anchor e
      pack [label $f1.ss_label -text [LT 2743]  ] \
       -fill y -expand true -anchor e
    pack $f1 -side left -expand true -fill y
#E
#A right column of table:    
    set f2 [frame $f0.f2]
      tk_optionMenu $f2.format animtype FLI GIF MPEG
      pack $f2.format  -fill y -expand true -anchor w
      set f3 [frame $f2.f3]
        pack [entry $f3.freq_entry -width 4 -textvariable freq] -side left -fill x -expand true 
        bind $f3.freq_entry <Enter> "focus $f3.freq_entry"
        pack [label $f3.freq_fps -text "fps" ] -side right
      pack $f3  -anchor w -fill y -expand true
      set f4 [frame $f2.f4]
        pack [entry $f4.animscale_entry -width 6 -textvariable animscale] \
             -side left -fill x -expand true 
        bind $f4.animscale_entry <Enter> "focus $f4.animscale_entry"
        pack [label $f4.animscale_label2 -text "%"  ] -side left
      pack $f4  -anchor w -fill y -expand true
      pack [entry $f2.animbitrate_entry -width 10  -textvariable animbitrate] \
            -fill x -expand true 
      bind $f2.animbitrate_entry <Enter> "focus $f2.animbitrate_entry"
#      pack [entry $f2.temp_entry -textvariable tempdir]  -fill x -expand true 
#      bind $f2.temp_entry <Enter> "focus $f2.temp_entry"
      pack [entry $f2.hardcopy_entry -textvariable hardcopydir]  -fill x -expand true 
      bind $f2.hardcopy_entry <Enter> "focus $f2.hardcopy_entry"
      pack [entry $f2.povout_entry -textvariable povraydir]  -fill x -expand true 
      bind $f2.povout_entry <Enter> "focus $f2.povout_entry"
      pack [entry $f2.ss_entry -textvariable siteswapdir]  -fill x -expand true 
      bind $f2.ss_entry <Enter> "focus $f2.ss_entry"
   pack $f2 -side left -fill both -expand true
#E  
  pack $f0  -fill both -expand true
  
  pack [frame $r.cb] -side left -fill x -expand true
  #pack [checkbutton $r.cb.playloop -text "make looping animation"]  -anchor w
  pack [checkbutton $r.cb.delsinglepics -text [ LT 2744]] -anchor w
  pack [checkbutton $r.cb.povray83 -text [ LT 2745]]  -anchor w
  
#pack $r      -side left  -padx 2 -pady 2 -fill both -expand yes

if { $DEBUG & 1 } { putsDebug "after export" }
#E
#----------------------------------------
#A     D E V E L O P 
if { $COMMERCIAL == 0 } {
    set r [frame $w.dev]
      set f0 [frame $r.f0]
        set f1 [frame $f0.f1]
          pack [label $f1.bgrtex -text "background texture" ]   -fill y -expand true -pady 5 -anchor e
          pack [label $f1.label1 -text "internal integer" ]   -fill y -expand true -pady 5 -anchor e
          pack [label $f1.label2 -text "internal text" ]   -fill y -expand true -pady 5 -anchor e
          pack [label $f1.maxfps -text "max fps" ]   -fill y -expand true -pady 5 -anchor e
        pack $f1 -side left -expand true -fill y
        
        set f2 [frame $f0.f2]
          pack [entry $f2.bgrtex  -textvariable bgrtex]  -fill x -expand true 
          bind $f2.bgrtex <Enter> "focus $f2.bgrtex"
          pack [entry $f2.entry1 -width 10 -textvariable internalInt]  -fill x -expand true 
          bind $f2.entry1 <Enter> "focus $f2.entry1"
          pack [entry $f2.entry2 -textvariable internalText]  -fill x -expand true 
          bind $f2.entry2 <Enter> "focus $f2.entry2"
          pack [entry $f2.maxfps -width 4 -textvariable maxfps]  -fill x -expand true 
          bind $f2.maxfps <Enter> "focus $f2.maxfps"
        pack $f2 -side left -fill both -expand true
      
        set f3 [frame $f0.f3]
          pack [checkbutton $f3.act1 -text "active"]  -anchor w -fill y -expand true
          pack [checkbutton $f3.act2 -text "active"]  -anchor w -fill y -expand true
          pack [checkbutton $f3.act3 -text "active"]  -anchor w -fill y -expand true
          pack [checkbutton $f3.act4 -text "active"]  -anchor w -fill y -expand true
        pack $f3 -side left -fill y -expand true
      pack $f0 -fill both -expand true -side top

			set f5 [frame $r.f5]
				set f4 [frame $f5.f4 -relief groove -bd 2]
					checkbutton $f4.nofork -text "nofork" 
					pack $f4.nofork -anchor w
					checkbutton $f4.show_bostonmess_call -text "show bostonmess call" 
					pack $f4.show_bostonmess_call  -anchor w
					checkbutton $f4.show_fart_call -text "show fart call" 
					pack $f4.show_fart_call -anchor w
					checkbutton $f4.show_j2_call -text "show j2 call" 
					pack $f4.show_j2_call -anchor w
					checkbutton $f4.show_s22j_call -text "show s22j call" 
					pack $f4.show_s22j_call  -anchor w
					checkbutton $f4.show_sstart_call -text "show sstart call" 
					pack $f4.show_sstart_call  -anchor w
				pack $f4 -side left 

				set f6 [frame $f5.f6]
				  pack [label $f6.l1 -text "internal Int:"]  -anchor n
				  pack [label $f6.l2 -text "& 1: write JMSG_DEBUG -> JMSG_INFO (Windows only)"] -anchor n
				pack $f6 -side right -expand true -fill both
  		pack $f5 -side bottom
				
    if { $DEBUG & 1 } { putsDebug "after develop" }
}
#E
#----------------------------------------
#A     end of main()

# From wm doc:
# BUGS 
# Most existing window managers appear to have bugs that affect the 
# operation of the wm command. For example, some changes won't 
# take effect if the window is already active: the window will have to 
# be withdrawn and de-iconified in order to make the change happen. 

if { [file exists $j2file] } {
    J2_fill_listbox
    $w.j2.lb.lb selection set $j2_active_index
    $w.j2.lb.lb see $j2_active_index
}

# default values -> ShowTransWindow won't display 
set xpos -1
set ypos -1

# TraceSS_options ss_options 0 w
# TraceTextures textures 0 w
if { $currentregister == "j2" } {
	TraceJ2 bla bla bla
}
ShowFrame $currentregister true

# compute real size of window:
update idletasks

# center current window on screen:
# (siehe S. 299 Ousterhout)
set xpos [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
              - [winfo vrootx [winfo parent $w]]]
set ypos [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
              - [winfo vrooty [winfo parent $w]]]
wm geom $w +$xpos+$ypos

wm deiconify .jongl

# after displaying main GUI window: check secondary windows
if { $currentregister ==  "j2" } {
		if { $j2_options_window == 1} { 
			J2_options_window on
		}
}
if { $currentregister == "j2" || $currentregister == "ss" } {
	TraceThrowTrans $show_trans_window bla bla
}

#E
#----------------------------------------
